var Chat = {
	student2chat: function(pos) {
        SetLS("chat_action", "chat");
		SetLS("chat_detail", GetLS("chat_student")[pos]);
		PCall("chat_detail", 'Chat.openChatWin()');
	},
	studentListInit: function() {
		$ajax({
			url: "/user/list",
			data: {GID:CurrentUser.group._id},
			success: function(res) {
				var items = res.result;
				SetLS("chat_student", items);
				var html = "";
				for (var i=0; i<items.length; ++i) {
					html += '<div class="ub up_list" ontouchstart="zy_touch()" onclick="Chat.student2chat(\''+ i +'\')">'+
					        '    <div class="uw3 uh3 ub_img_cover" style="background-image:url('+ Core.id2url(items[i]) +')"></div>'+
					        '    <div class="ub-f1 ub ub-ver upl_p5">'+
					        '        <div class="ub-f1 ub">'+
					        '            <div class="ub-f1 ub_left">'+ items[i].name +'　'+ items[i].sex +'</div>'+
					        '        </div>'+
					        '        <div class="ub_left ub-f1">'+ (items[i].content?items[i].content:"这个家伙很懒，什么也没留下。") +'</div>'+
					        '    </div>'+
					        '</div>';
				}
				$("#ctn").html(html);
			}
		});
	},
	openStudentWin: function() {
		$(".send_ctn").addClass("hide");
        Zycon("chat_list_student", $("#header").outerHeight());
	},
	openChatWin: function() {
		$(".send_ctn").removeClass("hide");
        Zycon("chat_detail_content", $("#header").outerHeight());
	},
	detailInit: function() {
		var type = GetLS("chat_type");
		var toStudent = GetLS("chat_detail");
		var data = {};
		if (type == "student") {
			data.TYPE = 0;
			data.TO = toStudent._id;
		} else if (type == "class") {
			data.TYPE = 1;
			data.TO = CurrentUser.group._id;
		} else if (type == "teacher") {
			data.TYPE = 0;
		}
		data.START = 0;
		data.COUNT = 50;
		data.GID = CurrentUser.group._id;

		var ajaxAfterFun = function(items, user){
			setTimeout(tmoFun, 1000*2);
			var html = Chat.gnHtml(items, user);
			$("#ctn").append(html);
			if (html != "")
				$(document).scrollTop($(document).height());
		}
		var tmoFun = function(){
			$ajax({
				url: "/message/list",
				data: data,
				success: function(res) {
					ajaxAfterFun(res.result, toStudent);
				}
			});
		};
		tmoFun();
	},
	send: function() {
		var msgcontent = $("#msg").val();
		if (msgcontent == "") {
			$alert("留言内容不能为空");
			return;
		}
		$("#msg").val("");

		var type = GetLS("chat_type");
		var toStudent = GetLS("chat_detail");
		var data = {};
		if (type == "student") {
			data.TYPE = 0;
			data.TO = toStudent._id;
		} else if (type == "class") {
			data.TYPE = 1;
			data.TO = CurrentUser.group._id;
		} else if (type == "teacher") {
			data.TYPE = 0;
		}
		data.MEDIA = 0;
		data.CONTENT = msgcontent;
		data.GID = CurrentUser.group._id;

		$ajax({
			url: "/message/add",
			data: data,
			success: function(res) {
				CCall("Chat.sendAppend('" + JSON.stringify(res.result) + "')");
			}
		});
	},
	sendPhoto: function() {
		Upload.init(Core.API_VER + "/upload", function(res) {
			res = res[0];
		 	if (res.code) {
		 		$alert(res.codemsg);
		 		return;
		 	}

			var type = GetLS("chat_type");
			var toStudent = GetLS("chat_detail");
			var data = {};
			if (type == "student") {
				data.TYPE = 0;
				data.TO = toStudent._id;
			} else if (type == "class") {
				data.TYPE = 1;
				data.TO = CurrentUser.group._id;
			} else if (type == "teacher") {
				data.TYPE = 0;
			}
			data.MEDIA = 1;
			data.CONTENT = res.result.url;

			$ajax({
				url: "/message/add",
				data: data,
				success: function(res) {
					Chat.sendAppend(JSON.stringify(res.result));
				}
			});
		});
	},
	sendAppend: function(item) {
		item = JSON.parse(item);
		var html = Chat.gnHtml(new Array(item), "self");
		$("#ctn").append(html);
		if (html != "")
			$(document).scrollTop($(document).height());
	},
	gnHtml: function(items, user) {
		var html = "";

		var flag = false;
		if (Chat.lastID && user != "self")
			flag = true;
		for (var i = 0; i < items.length; ++i) {
			if (flag) {
				if (items[i]._id == Chat.lastID)
					flag = false;
				continue;
			}
			var content = "";
			if (items[i].from == CurrentUser._id) {
				if (items[i].media == 0) {
					content = '	<div class="talk_ctn" style="float:right">' +
								'      	<div class="uc-a upp5 wb_a talk_ctn right umw3 uml_2" style="float:none;" ontouchstart="zy_touch(\'talk_ctn_act\', undefined, \'longpress\')" onclick="Appcan.copy(\''+ items[i].mcontent +'\');">' +
								'         	<div class="uwp5 uh1 ub_img im_talk_right"></div>' + items[i].content +
								'     	</div>' +
								'	<div class="ufp8 tx-r">' + Core.offsetDate(items[i].create) + '</div>' +
								'</div>';
				} else if (items[i].media == 1) {
					content = '<div class="uw7 uh5 ub_img_cover photoBrowserEvent" data-url="'+ items[i].content +'" style="background-image:url('+ Core.id2url(items[i].content, "photo") +'); background-size:cover; float:right" ontouchstart="zy_touch()" onclick="ImageBrowser(\'' + items[i].content + '\')"></div>'+
								'<div class="ufp8 tx-r" style="clear:both">' + Core.offsetDate(items[i].create) + '</div>';
				}
				html += '<div class="ub-f1 ub uptb_p5">' +
					'	 <div class="uw3"></div>' +
					'    <div class="ub-f1 upr_1">' + content +
					'    </div>' +
					'    <div class="uw3 uh3 umar-tp5 ub_img_cover uc-a" style="background-image:url(\'' + Core.id2url(CurrentUser) + '\');"></div>' +
					'</div>';
			} else {
				if (items[i].media == 0) {
					content = '<div class="talk_ctn">' +
							  '		<div class="uc-a upp5 wb_a talk_ctn left umw3 umar-r2" style="" ontouchstart="zy_touch(\'talk_ctn_act\', undefined, \'longpress\')" onclick="Appcan.copy(\''+ items[i].content +'\');">' +
							  '			<div class="uwp5 uh1 ub_img im_talk_left"></div>' + items[i].content +
							  '		</div>' +
							  '		<div class="ufp8 tx-l">' + Core.offsetDate(items[i].create) + '</div>' +
							  '</div>';
				} else if (items[i].media == 1) {
					content = '<div class="uw7 uh5 ub_img photoBrowserEvent" data-url="'+ items[i].content +'" style="background-image:url('+ Core.id2url(items[i].content, "photo") +'); background-size:cover;" ontouchstart="zy_touch()" onclick="ImageBrowser(\'' + items[i].content + '\')"></div>'+
								'<div class="ufp8 tx-l" style="clear:both">' + Core.offsetDate(items[i].create) + '</div>';
				}
				html += '<div class="ub-f1 ub uptb_p5">' +
					'    <div class="uw3 uh3 umar-tp5 ub_img_cover uc-a" style="background-image:url(\'' + Core.id2url(items[i]) + '\');"></div>' +
					'    <div class="ub-f1 upl_1">' + content +
					'    </div>' +
					'	 <div class="uw3"></div>' +
					'</div>';
			}
		}
		if (items[items.length-1] != undefined)
			Chat.lastID = items[items.length-1]._id;
		return html;
	}
}