var Core = {
	//API_VER:"http://192.168.1.162:9000",
	//IMG_VER:"http://192.168.1.162:9000/upload/",
	//ATTACH_VER:"http://192.168.1.162:9000/upload/FILE/",

	//API_VER:"http://115.29.149.91:9000",
	//IMG_VER:"http://115.29.149.91:9000/upload/",
	//ATTACH_VER:"http://115.29.149.91:9000/upload/FILE/",

	API_VER:"http://xiangxue8.com",
	IMG_VER:"http://xiangxue8.com/upload/",
	ATTACH_VER:"http://xiangxue8.com//upload/FILE/",

	//安卓的版本号
	VERSION:"1.1.2",
	offsetDate: function(UTCTime) {
		if (UTCTime == "" || UTCTime == undefined)
			return "";
		var now = new Date();
		var date = new Date(UTCTime);

		var offsetMS = parseInt((now.getTime() - date.getTime()) / 1000 / 60);
		if (offsetMS < 5)
			return "刚刚";
		else if (offsetMS < 60)
			return offsetMS + "分钟前";
		else if (now.pattern("yyyy-MM-dd") == date.pattern("yyyy-MM-dd"))
			return date.pattern("HH:mm");
		else if (now.pattern("yyyy") == date.pattern("yyyy"))
			return date.pattern("M月d日")
		else
			return date.pattern("yyyy年M月d日");
	},
	id2url: function(obj, from) {
		var url;
		if (from == "photo") {
			url = Core.IMG_VER + obj;
		} else if (obj.photo) {
			url = Core.IMG_VER + obj.photo;
		} else {
			switch (parseInt(obj.utype)) {
				case Role.TEACHER:
					url = "img/teacher.png";
					break;
				case Role.REG_STUDENT:
				case Role.UN_REG_STUDENT:
					url = "img/student.png";
					break;
			}
		}
		return url;
	},
	check: function() {
		if ($("#phone").val() == "") {
			$alert("手机号不能为空");
			return false;
		}
		if ($("#email").val() == "") {
			$alert("邮箱不能为空");
			return false;
		}
		if ($("#phonecode").val() == "") {
			$alert("验证码不能为空");
			return false;
		}
		if ($("#pwd").val() == "") {
			$alert("密码不能为空");
			return false;
		}
		if ($("#name").val() == "") {
			$alert("名字不能为空");
			return false;
		}
		if ($("#school").val() == "") {
			$alert("学校不能为空");
			return false;
		}
		if ($("#profession").val() == "") {
			$alert("专业不能为空");
			return false;
		}
		if ($("#edutime").val() == "") {
			$alert("毕业时间不能为空");
			return false;
		}
		return true;
	}
}


Array.prototype.pushh = function(val) {
	this.push(val);
	return this;
}
Array.prototype.find = function(key, val) {
	if (key == "") {
		for (var i = 0; i < this.length; ++i) {
			if (this[i] == val)
				return i;
		}
	} else {
		for (var i = 0; i < this.length; ++i) {
			if (this[i][key] == val)
				return this[i];
		}
	}
	return -1;
}
Array.prototype.remove = function(val) {
	if (this.find(val) >= 0)
		this.splice(this.find(val), 1);
}
String.prototype.replaceAll = function(str1, str2) {
	return this.replace(/str1/g, str2);
}

/** * 对Date的扩展，将 Date 转化为指定格式的String * 月(M)、日(d)、12小时(h)、24小时(H)、分(m)、秒(s)、周(E)、季度(q)
    可以用 1-2 个占位符 * 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字) * eg: * (new
    Date()).pattern("yyyy-MM-dd hh:mm:ss.S")==> 2006-07-02 08:09:04.423      
 * (new Date()).pattern("yyyy-MM-dd E HH:mm:ss") ==> 2009-03-10 二 20:09:04      
 * (new Date()).pattern("yyyy-MM-dd EE hh:mm:ss") ==> 2009-03-10 周二 08:09:04      
 * (new Date()).pattern("yyyy-MM-dd EEE hh:mm:ss") ==> 2009-03-10 星期二 08:09:04      
 * (new Date()).pattern("yyyy-M-d h:m:s.S") ==> 2006-7-2 8:9:4.18
 */

Date.prototype.pattern = function(fmt) {
	var o = {
		"M+": this.getMonth() + 1, //月份
		"d+": this.getDate(), //日
		"h+": this.getHours() % 12 == 0 ? 12 : this.getHours() % 12, //小时 (12小时制)
		"H+": this.getHours(), //小时 (24小时制)
		"m+": this.getMinutes(), //分
		"s+": this.getSeconds(), //秒
		"q+": Math.floor((this.getMonth() + 3) / 3), //季度
		"S": this.getMilliseconds() //毫秒
	};
	var week = {
		"0": "/u65e5",
		"1": "/u4e00",
		"2": "/u4e8c",
		"3": "/u4e09",
		"4": "/u56db",
		"5": "/u4e94",
		"6": "/u516d"
	};
	if (/(y+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	}
	if (/(E+)/.test(fmt)) {
		fmt = fmt.replace(RegExp.$1, ((RegExp.$1.length > 1) ? (RegExp.$1.length > 2 ? "/u661f/u671f" : "/u5468") : "") + week[this.getDay() + ""]);
	}
	for (var k in o) {
		if (new RegExp("(" + k + ")").test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		}
	}
	return fmt;
}


//获取这个月一共多少天
function GetDaysInMonth(year, month){
      month = parseInt(month,10)+1;
      var temp = new Date(year+"/"+month+"/0");
      return temp.getDate();
}

function ShowLoading(isShow) {
	if (IsLoading)
		return true;
	IsLoading = true;
	if (isShow == undefined) {
		Timeout = setTimeout(function() {
			$("body").append('<div class="uw3 uh3 im_loading ub_img loading"></div>');
		}, 500);
	}
	return false;
}

function HideLoading() {
	IsLoading = false;
	clearTimeout(Timeout);
	Timeout = 0;
	$(".loading").remove();
}
function cconfirm(message, sucFun, cancelFun, arg){
	 uexWindow.cbConfirm = function(opId,dataType,data){
      if(data == 0)
      	sucFun(arg);
	  else if(data == 1)
	  	HideLoading();
	  	if (cancelFun)
	  		cancelFun();
     }
     uexWindow.confirm("提示信息", message, ["确定","取消"]);
}
var ajaxUrl = {};
function $ajax(opt) {
	opt.url = Core.API_VER+opt.url;
	if (ajaxUrl[opt.url]) {
		return false;
	}
	ajaxUrl[opt.url] = true;
	opt.dataType = "json";
	opt.type = "post";
	opt.error = function(XMLHttpRequest, textStatus) {
		var status = XMLHttpRequest.status;
		if (status == 0)
			return;
		else if (status == 500)
			$alert("服务器错误");
		else
			$alert("请检查您的网络。");
	};
	opt.goSuccess = opt.success;
	opt.success = function(res) {
		if (res.code) {
			if (res.code != 999){
				$alert(res.codemsg);
				if (res.code == 100)
					OpenNewWin("signup");
			}	
		}
		else
			opt.goSuccess(res);
	}
	opt.complete = function() {
		delete ajaxUrl[opt.url];
	}
	$.ajax(opt);
}

var CurrentUser = GetLS("user");
