var Work = {
	WEEK_DAY: {1:"一", 2:"二", 3:"三", 4:"四", 5:"五", 6:"六", 0:"日"},
	url: "",
	filename: "",
	pos: 0,
	init: function() {
		
	},
	examInit: function() {
		$ajax({
			url: "/course/list",
			data: {"GID":CurrentUser.group._id},
			success: function(res) {
				var items = res.result;
				Work.lesson = items;
				$("#lessonSelected").text(items[0].name);
				Work.getKnowledgeList();
			}
		});
	},
	getKnowledgeList: function() {
		$("#ctn").html("");
		$ajax({
			url: "/course/listKnowledge",
			data: {"GID":CurrentUser.group._id, "CID":Work.lesson[Work.pos]._id},
			success: function(res) {
				var items = res.result[0].chapter;
				if (items.length == 0) {
					$("#chapterList").html('<div class="uptb_p5">暂时没有章节</div>');
					return;
				}
				var html = "";
				if (CurrentUser.type == Role.REG_STUDENT || CurrentUser.type == Role.UN_REG_STUDENT) {
					for (var i=0; i<items.length; ++i) {
						html += '<div class="uptb_p5 ub" ontouchstart="zy_touch()" onclick="Work.switch();">'+
									'<div class="ub-f1 nowrap">'+ items[i].name +'</div>'+
									// '<div class="uw4">'+ items[i].score +'分</div>'+
									// '<div class="uw4">排名'+ items[i].num +'</div>'+
									'<div></div>'+
								'</div>';
						html += '<div class="ufp9 hide">';
						for (var j=0; j<items[i].knowledge.length; ++j) {
							var knowledge = items[i].knowledge;
							if (knowledge[j] == null)
								break;
							html += '<div class="up_list childctn ub_center" data-pos="0" ontouchstart="zy_touch()" onclick="Work.studentExamDetail(\''+ knowledge[j].name +'\', \''+ knowledge[j]._id +'\');">'+
									'	<div class="ub_img im_point uw1 uh1"></div>'+
									'	<div class="ub-f1 nowrap">'+ knowledge[j].name +'</div>'+
									'	<div class="uw4">'+ knowledge[j].score +'分</div>'+
									'	<div class="uw4">排名'+ knowledge[j].num +'</div>'+
									'</div>'
						}
						html += '</div>';
					}
				} else if (CurrentUser.type == Role.TEACHER) {
					for (var i=0; i<items.length; ++i) {
						html += '<div class="uptb_p5" ontouchstart="zy_touch()" onclick="Work.examDetail(\''+ items[i]._id +'\');">'+ items[i].name +'</div>';
					}
				}
				$("#chapterList").html(html);
			}
		});
	},
	switch: function() {
		var $this = $(event.currentTarget);
		$this.next().toggleClass("hide");
	},
	studentExamDetail: function(name, id) {
		SetLS("knowledge", {"title":name, "_id":id});
		OpenNewWin("work_exam_detail");
	},
	examDetail: function(id) {
		$ajax({
			url: "/exam/getResult",
			data: {GID:CurrentUser.group._id, PID: id},
			success: function(res) {
				var items = res.result;
				var examHtml = "", examCount = 0, unexamHtml = "", unexamCount = 0;
				for (var i=0; i<items.length; ++i) {
					if (items[i].score) {
						if (examHtml == "")
							examHtml = '<div class="up_list"><div class="uf1p4">已考试学生</div>';
						if (examCount%2 == 0)
							examHtml += '<div class="ub">';
						examHtml += '<div class="ub ub-f1 ub-con">'+
					                '    <div class="uw3p5 uh3p5 ub_center"><div class="uw2p5 uh2p5 ub_img_cover" style="background-image:url('+ Core.id2url(items[i]) +')"></div></div>'+
					                '    <div class="ub-f1 ub ub-ver ufp9">'+
					                '        <div class="ub-f1 ub_left">'+ items[i].name +' '+ items[i].score +'分</div>'+
					                '        <div class="ub-f1 ub_left">'+ (new Date(items[i].create)).pattern("yyyy-MM-dd") +'</div>'+
					                '    </div>'+
					                '</div>';
						++examCount;
						if (examCount%2 == 0)
							examHtml += '</div>';
					} else {
						if (unexamHtml == "")
							unexamHtml = '<div class="up_list"><div class="uf1p4">未考试学生</div>';
						if (unexamCount%2 == 0)
							unexamHtml += '<div class="ub">';
						unexamHtml += '<div class="ub ub-f1 ub-con">'+
					                '    <div class="uw3p5 uh3p5 ub_center"><div class="uw2p5 uh2p5 ub_img_cover" style="background-image:url('+ Core.id2url(items[i]) +')"></div></div>'+
					                '    <div class="ub-f1 ub ub-ver">'+
					                '        <div class="ub-f1 ub_left">'+ items[i].name +'</div>'+
					                '    </div>'+
					                '</div>';
						++unexamCount;
						if (unexamCount%2 == 0)
							unexamHtml += '</div>';
					}
				}
				if (examHtml != "") {
					if (examCount%2 != 0)
						examHtml += '<div class="ub ub-f1 ub-con"></div></div>';
					examHtml += '</div>';
				}
				if (unexamHtml != "") {
					if (unexamCount%2 != 0)
						unexamHtml += '<div class="ub ub-f1 ub-con"></div></div>';
					unexamHtml += '</div>';
				}
				$("#ctn").html('<div class="up_list" style="border-top:0px;">'+
						            '<div class="uf1p4">考试完成率　'+ (examCount/(examCount+unexamCount)).toFixed(2)*100 +'%</div>'+
						            '<div class="ufp8">应考试：'+ (examCount+unexamCount) +'人，已考试：'+ examCount +'人，未考试：'+ unexamCount +'人</div>'+
						        '</div>'+examHtml+unexamHtml);
			}
		});
	},
	choseFile: function() {
		Upload.init(Core.API_VER+"/homework/submitFile", function(res){
			res = res[0];
			if (!res.code) {
				Work.url = res.result.url;
				Work.filename = res.result.filename;
				$("#attach").show();
				$("#filename").text(Work.filename);
				$("#attach").attr("onclick", 'OpenAttach("'+ Work.fileName +'", "'+ Work.url +'")');
			}
		}, false, true);
	},
	// selectCtn: function() {
	// 	$("#selectCtn").toggleClass('hide');
	// },
	select: function() {
		var titleArr = [];
		for (var i=0; i<Work.lesson.length; ++i)
			titleArr.push(Work.lesson[i].name);
		ActionSheet("选择课程", "取消", titleArr, function(data){
			$("#lessonSelected").text(titleArr[data]);
			Work.pos = data;
			Work.getKnowledgeList();
		});
	},
	cbFn: function(no, month, year) {
		if (no == "切换") {
			uexControl.openDatePicker(year, month, 1);
			uexControl.cbOpenDatePicker = function(opId, dataType, data) {
				var json = JSON.parse(data.replace(/'/g, "\""));
		        var menu = Work.gnDay(json.year, json.month);
		        menu.select = parseInt(json.day);
		        menu.cbFn = "Work.cbFn";
		        SetLS("date_header", menu);
		        CCall('init()', 'headerMenu');
			}
			return;
		}
		$ajax({
			url: "/homework/detail",
			data: {DATE:year+"-"+month+"-"+no, GID:CurrentUser.group._id},
			success: function(res) {
                var items = res.result.results;
				if (CurrentUser.type == Role.REG_STUDENT || CurrentUser.type == Role.UN_REG_STUDENT) {
					if (res.result.homework.name == "" || res.result.homework.name == undefined) {
						SetLS("work_home", "");
						$("#ctn").html('<div class="ub_center up_base c_base ubt b_base">今天老师还没有留作业！</div>');
					}
					else {
						SetLS("work_home", res.result);
						$("#ctn").html('<div class="up_list">作业描述：'+ res.result.homework.name +'</div>');
					}
				} else if (CurrentUser.type == Role.TEACHER) {
                    if(items.length == 0)
					   $("#ctn").html('<div class="ub_center up_base c_base ubt b_base">今天没有作业统计</div>');
					else
					   $("#ctn").html('');
				}
				
				var html = "";
				if (res.result.homework.attach) {
				    html += '<div id="attach" class="up_list" ontouchstart="zy_touch()" onclick="OpenAttach(\''+ res.result.homework.fileName +'\', \''+ res.result.homework.attach +'\')">'+
						        '<div style="font-weight:bold;">作业附件</div>'+
						        '<div class="ub umt_1">'+
						            '<div class="ub-img im_attach uw3p5 uh2p5"></div>'+
						            '<div id="filename" class="nowrap ub ub-ac">'+ res.result.homework.fileName +'</div>'+
						        '</div>'+
						    '</div>';
				}
				$("#ctn").append(html);

				if(items.length == 0)
					return;
				if (CurrentUser.type == Role.REG_STUDENT || CurrentUser.type == Role.UN_REG_STUDENT) {
					Work.studentHomeWorkDetail(items);
				} else if (CurrentUser.type == Role.TEACHER) {
					Work.teacherHomeWorkDetail(items);
				}
			}
		});
	},
	studentHomeWorkDetail: function(items) {
		var item = items[items.length-1];
		var html = '<div class="up_list">'+
					'<div class="uf1p4">回答：</div>'+
					'<div style="text-indent:2.8em;">'+ (item.content?item.content:"无") +'</div>'+
				   '</div>';
		if (item.attach) {
		    html += '<div id="attach" class="up_list" ontouchstart="zy_touch()" onclick="OpenAttach(\''+ item.filename +'\', \''+ item.attach +'\')">'+
				        '<div style="font-weight:bold;">提交作业附件</div>'+
				        '<div class="ub umt_1">'+
				            '<div class="ub-img im_attach uw3p5 uh2p5"></div>'+
				            '<div id="filename" class="nowrap ub ub-ac">'+ item.fileName +'</div>'+
				        '</div>'+
				    '</div>';
		}
		$("#ctn").append(html);
	},
	teacherHomeWorkDetail: function(items) {
		var workHtml = "", workCount = 0, unworkHtml = "", unworkCount = 0;
		for (var i=0; i<items.length; ++i) {
			if (items[i].stu_attach) {
				if (workHtml == "")
					workHtml = '<div class="up_list"><div class="uf1p4">已交作业学生</div>';
				if (workCount%2 == 0)
					workHtml += '<div class="ub">';
				workHtml += '<div class="ub ub-f1 ub-con">'+
			                '    <div class="uw3p5 uh3p5 ub_center"><div class="uw2p5 uh2p5 ub_img_cover" style="background-image:url('+ Core.id2url(items[i]) +')"></div></div>'+
			                '    <div class="ub-f1 ub ub-ver ufp9">'+
			                '        <div class="ub-f1 ub_left">'+ items[i].name +'</div>'+
			                '        <div class="ub-f1 ub_left">'+ (new Date(items[i].create)).pattern("yyyy-MM-dd") +'</div>'+
			                '        <div class="ub-f1 ub_left" style="width:200%;" ontouchstart="zy_touch()" onclick="OpenAttach(\''+ items[i].fileName +'\', \''+ items[i].stu_attach +'\')">'+"附件:"+ (items[i].fileName?items[i].fileName:"无") +'</div>'+
			                '    </div>'+
			                '</div>';
				++workCount;
				if (workCount%2 == 0)
					workHtml += '</div>';
			} else {
				if (unworkHtml == "")
					unworkHtml = '<div class="up_list"><div class="uf1p4">未交作业学生</div>';
				if (unworkCount%2 == 0)
					unworkHtml += '<div class="ub">';
				unworkHtml += '<div class="ub ub-f1 ub-con">'+
			                '    <div class="uw3p5 uh3p5 ub_center"><div class="uw2p5 uh2p5 ub_img_cover" style="background-image:url('+ Core.id2url(items[i]) +')"></div></div>'+
			                '    <div class="ub-f1 ub ub-ver">'+
			                '        <div class="ub-f1 ub_left">'+ items[i].name +'</div>'+
			                '    </div>'+
			                '</div>';
				++unworkCount;
				if (unworkCount%2 == 0)
					unworkHtml += '</div>';
			}
		}
		if (workHtml != "") {
			if (workCount%2 != 0)
				workHtml += '<div class="ub ub-f1 ub-con"></div></div>';
			workHtml += '</div>';
		}
		if (unworkHtml != "") {
			if (unworkCount%2 != 0)
				unworkHtml += '<div class="ub ub-f1 ub-con"></div></div>';
			unworkHtml += '</div>';
		}
		$("#ctn").append('<div class="up_list">'+
				            '<div class="uf1p4">作业完成率　'+ (workCount/(workCount+unworkCount)).toFixed(2)*100 +'%</div>'+
				            '<div class="ufp8">应交：'+ (workCount+unworkCount) +'人，实交：'+ workCount +'人，未交：'+ unworkCount +'人</div>'+
				        '</div>'+workHtml+unworkHtml);
	},
	gnDay: function(year, month) {
		month = parseInt(month);
		var date = new Date();
		var flag = false;
		var nowDay;
		if (month == date.getMonth()+1) {
			flag = true;
			nowDay = date.getDate();
		}
		date.setFullYear(year);
		date.setMonth(month-1);
		var day = Work.getDayCount(year, month);
		var menu = {items:[]};
		for (var i=1; i<=day; ++i) {
			if (flag && i > nowDay)
				break;
			date.setDate(i);
			menu.items[i-1] = {day:i, weekDay:Work.WEEK_DAY[date.getDay()]};
		}
		menu.items.splice(0, 0, {day:"切换", month:month, year:year});
		menu.type = "day";
		return menu;
	},
	getDayCount: function(year, month) {
		var count = 0;
		if(month == 2){
			if((year%4 == 0 && year%100 !=0) || (year%400 ==0))
				count = 29;
			else
				count = 28;
		}
		else if(month==1 || month==3 || month==5 || month==7|| month==8 || month==10  || month==12)
			count = 31;
		else if(month==4 || month==6 || month==9 || month==11)
			count = 30;
		return count;
	}
}