var Course = { 
	courseInit: function(){ 
		var _id = GetLS("courseId");
		$ajax({
			url: "/course/detailCourse",
			data: {
				_id: _id
			},
			success: function(res){ 
				var html = "";
				var result = res.result.chapter; 
				SetLS("course",res.result);
				SetLS("chapters",result);
				for (var i=0; i<result.length; ++i) {
					if (result[i].ctype == 0) {
						html += '<div class="up_list ub" data-pos="'+ i +'" ontouchstart="zy_touch()" onclick="Course.switch();">'+
							        '<div class="ub-f1 nowrap uf1p1">'+ result[i].name +'</div>' +         
									'<div class="uw5p5">'+ result[i].knowledge.length +'个节</div>' + 
								'</div>';
					} else { 
						html += '<div class="up_list ub" data-pos="'+ i +'" ontouchstart="zy_touch()" onclick="Course.jumpExam(\'' + i + '\');">'+
							        '<div class="ub-f1 nowrap uf1p1">'+ result[i].name +'</div>' +         
								'</div>';
					}		
					html += '<div class="hide ufp9 knowEvt">';
					for (var j=0; j<result[i].knowledge.length; ++j) {
						var knowledge = JSON.stringify(result[i].knowledge);
						html += '<div class="up_list childctn ub_center" data-pos="'+ j +'" ontouchstart="zy_touch()" onclick="Course.jump(\'' + i + '\',\'' + j + '\');">'+
									'<div class="ub_img im_point uw1 uh1"></div>'+
							        '<div class="ub-f1 nowrap">'+ result[i].knowledge[j].name +'</div>'+
							    '</div>';
						//html += '</div></div>';
					}
					html += '</div>';
				}
				$("body").html(html);
			}
		});	
	},
	switch: function() {
		var $this = $(event.currentTarget);
		$(".knowEvt").addClass("hide");
		$this.next().toggleClass("hide");
	},
	jump: function(i,j){ 
		var chapters = GetLS("chapters");
		var knowledge = chapters[i].knowledge[j];
		SetLS("chapter",chapters[i]);
		SetLS("knowledge",knowledge);
		SetLS("ktitle",knowledge.name);
		OpenNewWin("course_knowledge");
	},
	knowledgeInit: function(){ 
		var knowledge = GetLS("knowledge");
		console.log(knowledge);
		//视频区域
		//$("#player").before('<div class="ufp9 upl_p5">点击下面图片播放视频</div>');
		if (knowledge.first_image)
			$("#player").html('<img src="' + knowledge.first_image + '" style="width:100%;max-height: 13em;" ontouchstart="zy_touch()" onclick="Course.openVideo();"><div class="im_play ub-img" style="position:absolute;height:40%;width:40%;top:30%;left:30%;" ontouchstart="zy_touch()" onclick="Course.openVideo();"></div>');
		else
			$("#player").html('<div class="ub ub-ac ub-pc uf1p8" style="width:100%;max-height: 13em;min-height: 4em;">暂无视频</div>');
		//每课一练
		//var examItem = GetLS("examItem");
		SetLS("examItem",knowledge);
		Course.examFn("exam",knowledge.exam);
		$(".score").addClass("hide");
		//答疑
		var course = GetLS("course");
		if (course.tutors.length!= 0){
			var tutors = course.tutors

			$("#teacherPhoto").css("background-image","url('" + Core.id2url(tutors[0]) + "')");
			$("#teacherName").text(course.tutors[0].name);
			Course.messaageInit(course.tutors[0]._id);
			//var messTimeOut = setTimeout(Course.messaageInit(course.tutors[0]._id), 1000*2);
			SetLS("tutor",course.tutors[0]);
		} else 
			SetLS("tutor","");		
		//评论
		Course.commentInit(knowledge._id);
	},
	openVideo: function(){ 
		if (CurrentUser){
			var studyData = {};
			studyData.cid = GetLS("course")._id;
			studyData.chid = GetLS("chapter")._id;
			studyData.kid = GetLS("knowledge")._id;
			studyData.field = "video";
			$ajax({
				url:"/course/study",
				data:studyData,
				success: function(res){
				}
			});	
		}	
		var vid = GetLS("knowledge").vid;
		$.ajax({
			url: "http://v.polyv.net/videojson/" + vid + ".js",
			dataType:"json",
			success: function(res){ 
				uexVideo.open(res.hlsIndex, 1);
			}
		});
	},
	messaageInit: function(to){ 
		var data = new Object();
		data.to = to;
		data.knowledge = GetLS("knowledge")._id;

		$ajax({
			url: "/message/list",
			data: data,
			success: function(res){
				var data = res.result;
				var html = Course.gnHtml(data);
				$("#messList").html(html);
			}
		});
	},
	send: function() {
		var msgcontent = $("#msg").val();
		if (msgcontent == "") {
			$alert("留言内容不能为空");
			return;
		}
		$("#msg").val("");

		var data = new Object();
		data.content = msgcontent;
		data.media = 0;
		
		var mType = GetLS("mType");
		if (!GetLS("tutor")&&mType == "message"){ 
			$alert("该课程下暂时没有老师，无法完成答疑功能");
			return;
		}
		if (mType == "message"){ 
			data.knowledge = GetLS("knowledge")._id;
			data.to = GetLS("tutor")._id;
			$ajax({
				url: "/message/add",
				data: data,
				success: function(res){
					CCall("Course.sendAppend('" + JSON.stringify(res.result) + "')");
				}
			});
		} else if (mType == "comment"){ 
			data.cid = GetLS("courseId");
			data.chid = GetLS("chapter")._id;
			data.kid = GetLS("knowledge")._id;

			$ajax({
				url: "/comment/upsert",
				data: data,
				success: function(res){
					res.result.ownerType = CurrentUser.utype;
					res.result.ownerPhoto = CurrentUser.photo;
					CCall("Course.sendCommentAppend('" + JSON.stringify(res.result) + "')");
				}
			});
		}
	},
	sendPhoto: function() {

		Upload.init(Core.API_VER + "/upload", function(res) {

		 	if (res.code) {
		 		$alert(res.codemsg);
		 		return;
		 	}
		 	var data = new Object();
			data.media = 1;
			data.content = res.result.url;

			var mType = GetLS("mType");
			if (mType == "message"){

				data.knowledge = GetLS("knowledge")._id;
				data.to = GetLS("tutor")._id;
				$ajax({
					url: "/message/add",
					data: data,
					success: function(res) {  
						Course.sendAppend(JSON.stringify(res.result));
					}
				});
			} else if (mType == "comment"){

				data.cid = GetLS("courseId");
				data.chid = GetLS("chapter")._id;
				data.kid = GetLS("knowledge")._id;
				$ajax({
					url: "/comment/upsert",
					data: data,
					success: function(res){
						Course.sendCommentAppend(JSON.stringify(res.result));
					}
				});
			}	
		});
	},
	sendAppend: function(item) {
		item = JSON.parse(item);
		var html = Course.gnHtml(new Array(item));
		$("#messList").append(html);
	},
	sendCommentAppend: function(item){ 
		item = JSON.parse(item);
		var html = Course.gnCommentContent(new Array(item));
		$("#commentList").prepend(html);
	},
	gnHtml: function(items) {
		var html = "";
		for (var i = 0; i < items.length; ++i) {
			var content = "";
			if (items[i].from == CurrentUser._id) {
				if (items[i].media == 0) {
					content = '	<div class="talk_ctn" style="float:right">' +
								'      	<div class="uc-a upp5 wb_a talk_ctn right umw3 uml_2" style="float:none;" ontouchstart="zy_touch(\'talk_ctn_act\', undefined, \'longpress\')" onclick="Appcan.copy(\''+ items[i].content +'\');">' +
								'         	<div class="uwp5 uh1 ub_img im_talk_right"></div>' + items[i].content +
								'     	</div>' +
								'	<div class="ufp8 tx-r">' + Core.offsetDate(items[i].create) + '</div>' +
								'</div>';
				} else if (items[i].media == 1) {
					content = '<div class="uw7 uh5 ub_img_cover photoBrowserEvent" data-url="'+ items[i].content +'" style="background-image:url('+ Core.id2url(items[i].content, "photo") +'); background-size:cover; float:right" ontouchstart="zy_touch()" onclick="ImageBrowser(\'' + items[i].content + '\')"></div>'+
								'<div class="ufp8 tx-r" style="clear:both">' + Core.offsetDate(items[i].create) + '</div>';
				}
				html += '<div class="ub-f1 ub uptb_p5">' +
					'	 <div class="uw3"></div>' +
					'    <div class="ub-f1 upr_1">' + content +
					'    </div>' +
					'    <div class="uw3 uh3 umar-tp5 ub_img_cover uc-a" style="background-image:url(\'' + Core.id2url(CurrentUser) + '\');"></div>' +
					'</div>';
			} else {
				items[i].photo = items[i].fromUrl;
				if (items[i].media == 0) {
					content = '<div class="talk_ctn">' +
							  '		<div class="uc-a upp5 wb_a talk_ctn left umw3 umar-r2" style="" ontouchstart="zy_touch(\'talk_ctn_act\', undefined, \'longpress\')" onclick="Appcan.copy(\''+ items[i].content +'\');">' +
							  '			<div class="uwp5 uh1 ub_img im_talk_left"></div>' + items[i].content +
							  '		</div>' +
							  '		<div class="ufp8 tx-l">' + Core.offsetDate(items[i].create) + '</div>' +
							  '</div>';
				} else if (items[i].media == 1) {
					content = '<div class="uw7 uh5 ub_img photoBrowserEvent" data-url="'+ items[i].content +'" style="background-image:url('+ Core.id2url(items[i].content, "photo") +'); background-size:cover;" ontouchstart="zy_touch()" onclick="ImageBrowser(\'' + items[i].content + '\')"></div>'+
								'<div class="ufp8 tx-l" style="clear:both">' + Core.offsetDate(items[i].create) + '</div>';
				}
				html += '<div class="ub-f1 ub uptb_p5">' +
					'    <div class="uw3 uh3 umar-tp5 ub_img_cover uc-a" style="background-image:url(\'' + Core.id2url(items[i]) + '\');"></div>' +
					'    <div class="ub-f1 upl_1">' + content +
					'    </div>' +
					'	 <div class="uw3"></div>' +
					'</div>';
			}
		}
		return html;
	},
	selectTeacher: function(){  
		var tutors = GetLS("course").tutors;
		var titleArr = [];
		for (var i = 0; i < tutors.length; ++i)
			titleArr.push(tutors[i].name);
		ActionSheet("请选择老师", "取消", titleArr, function(data) {
			$("#teacherName").text(titleArr[data]);
			$("#teacherPhoto").css("background-image","url('" + Core.id2url(tutors[data]) + "')");
			SetLS("tutor",tutors[data]);
			//clearTimeout(messTimeOut);
			Course.messaageInit(tutors[data]._id);
			//setTimeout(Course.messaageInit(course.tutors[data]._id), 1000*2);
		});
	},
	commentInit: function(knowledgeId){ 
		$ajax({
			url: "/comment/list",
			data: {
				kid: knowledgeId
			},
			success: function(res){
				var data = res.result.results;
				var html = Course.gnCommentContent(data);
				$("#commentList").html(html);
			}
		});
	},
	gnCommentContent: function(item){
		var html = "";
		var ownerName = CurrentUser.name;
		for (var i = 0; i < item.length;i ++){
			if (item[i].ownerName)
				ownerName = item[i].ownerName;
			var owner = new Object();
			owner.utype = item[i].ownerType;
			owner.photo = item[i].ownerPhoto;
			if (item[i].media == 0) {
			    html += '<div class="ub-f1 ub upp5" style="border-bottom: 1px dotted #ccc;">' + 
						'	<div class="ub-img uh3 uw3" style="border-radius:50%;background-image:url(\'' + Core.id2url(owner) + '\')"></div>' + 
						'	<div class="ub-f1 ub ub-ver upl_p5">' + 
						'		<div class="ub">' + 
						'			<div class="ub-f1 upp3">' + ownerName + '</div>' + 
						'			<div class="ufp9 ub ub-ac upp3">' + (new Date(item[i].create)).pattern("yyyy-MM-dd HH:mm:ss") + '</div>' + 
						'		</div>' + 
						'		<div class="ufp9 upp3" style="padding-top:0;">' + item[i].content + '</div>' + 
						'	</div>' + 
						'</div>';
			} else if (item[i].media == 1) {	
				html += '<div class="ub-f1 ub ub-ver upp5 upt_1" style="border-bottom: 1px dotted #ccc;">' + 
						'	<div class="ub commentCon upp5 uc-a">' + 
						'		<div class="tx-l ub-f1 umr_p5 ufp9 uw3 uh3" data-url="'+ item[i].content +'" style="background-image:url('+ Core.id2url(item[i].content, "photo") +'); background-size:cover;" ontouchstart="zy_touch()" onclick="ImageBrowser(\'' + item[i].content + '\')"></div>' + 
						'		<div class="tx-r ufp8 c_red">' + ownerName + '</div>' + 
						'	</div>' + 
						'	<div class="tx-r upp5 ufp8">' + (new Date(item[i].create)).pattern("yyyy-MM-dd HH:mm:ss") + '</div>' + 
						'</div>';
			}		
		}				
	    return html;            
	},
	jumpExam: function(i){ 
		SetLS("examItem",GetLS("chapters")[i]);
		var ktitle = GetLS("chapters")[i].ctype==1?"阶段作业":"结业考试";
		SetLS("ktitle",ktitle);
		OpenNewWin("course_exam");
	},
	examInit: function(){ 
		var examItem = GetLS("examItem");
		console.log(examItem);
		if (examItem.ctype == 2){
			$.ajax({
				url: "http://ksapi.lndx.edu.cn/exam/GetExamQuestionsByKP?kpname="+ GetLS('course').name +"&AccessToken=17f15623-2d37-4f4e-b034-a46c669ff7f4&QuestionInfo=" + examItem.extra,
				type: "get",
				success: function(res){
					examItem.exam = res;
					SetLS("examItem",examItem);
					Course.examFn("content",res);
				}
			});
		} else {
			Course.examFn("content",examItem.exam);
			$(".score").addClass("hide");
		}	
	},
	examFn: function(htmlId,res){ 
		var html = "";
		for (var i = 0; i < res.length; i ++){
			if (res[i].QuestionType == EXAMTYPE.SINGLE_CHOICE){
				html += '<div class="cnt" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
                            '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
                            '<ul>' + 
                                '<h5>' + res[i].Content + '</h5>';
                    for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
                    	html += '<li>' + 
                                    '<label><input type="radio" class="uw2 uh2" data-ifrightanswer="' + res[i].QuestionOptionList[j].IfRightAnswer + '" name="' + res[i].QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</label>' + 
                                '</li>';
                    }      		
                    html +=  '</ul>' + 
                    		 '<h4 class="hide tipEvt c_red" style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
		                        	if (res[i].QuestionOptionList[j].IfRightAnswer == "true"){
		                        		html += '<p class="t-bla hide tipEvt" style="padding-left:3em;">' + res[i].QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		             html +='<div class="hide tipEvt t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 : </font>' + res[i].Tip + '</div>' +     
                        '</div>';      
			}
			else if (res[i].QuestionType == EXAMTYPE.MULTIPLE_CHOICE){
				html += '<div class="cnt" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
                            '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
                            '<ul>' + 
                                '<h5>' + res[i].Content + '</h5>';
                    for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
                    	html += '<li>' + 
                                    '<label><input type="checkbox" class="uw2 uh2" data-ifrightanswer="' + res[i].QuestionOptionList[j].IfRightAnswer + '" name="' + res[i].QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</label>' + 
                                '</li>';
                    }      
                    html +=  '</ul>' + 
                    		 '<h4 class="hide tipEvt c_red" style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
		                        	if (res[i].QuestionOptionList[j].IfRightAnswer == "true"){
		                        		html += '<p class="t-bla hide tipEvt" style="padding-left:3em;">' + res[i].QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		                html +='<div class="hide tipEvt t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 : </font>' + res[i].Tip + '</div>' +         
                        '</div>';      
			}
			else if (res[i].QuestionType == EXAMTYPE.JUDGE){
				html += '<div class="cnt" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
                            '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
                            '<ul>' + 
                                '<h5>' + res[i].Content + '</h5>';
                    for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
                    	html += '<li>' + 
                                    '<label><input type="radio" class="uw2 uh2" data-ifrightanswer="' + res[i].QuestionOptionList[j].IfRightAnswer + '" name="' + res[i].QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</label>' + 
                                '</li>';
                    }      
                    html +=  '</ul>' + 
                    		 '<h4 class="hide tipEvt c_red" style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
		                        	if (res[i].QuestionOptionList[j].IfRightAnswer == "true"){
		                        		html += '<p class="t-bla hide tipEvt" style="padding-left:3em;">' + res[i].QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		                html +='<div class="hide tipEvt t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 : </font>' + res[i].Tip + '</div>' +         
                        '</div>';      
			}
			else if (res[i].QuestionType == EXAMTYPE.FILL){
				html += '<div class="cnt" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
                            '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
                            '<ul>' + 
                                '<h5>' + res[i].Content + '</h5>' + 
                    			'<label><input class="uba uw100 uh2 ump50 uf1p1" type="text" id="' + res[i].Id + '"></label>';
                    			for ( var j = 0; j < res[i].QuestionOptionList.length; j ++){
                    				html += '<input type="hidden" id="' + res[i].QuestionOptionList[j].Id + '" value="' + res[i].QuestionOptionList[j].Content + '">';
                    			}
                   	html += '<div class="hide tipEvt t-bla" style=""><font style="font-weight:bolder;">解析 : </font>' + res[i].Tip + '</div>' + 
                   			'</ul>' + 
                        '</div>';      
			}
			else if (res[i].QuestionType == EXAMTYPE.SUBJECTIVE){
				html += '<div class="cnt" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
                            '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
                            '<ul>' + 
                                '<h5>' + res[i].Content + '</h5>' + 
                    			'<label><textarea class="uf1p1" id="' + res[i].Id + '"></textarea></label>';
                    			for ( var j = 0; j < res[i].QuestionOptionList.length; j ++){
                    				html += '<input type="hidden" id="' + res[i].QuestionOptionList[j].Id + '" value="' + res[i].QuestionOptionList[j].Content + '">';
                    			}
                   	html += '<div class="hide tipEvt t-bla" style=""><font style="font-weight:bolder;">解析 : </font>' + res[i].Tip + '</div>' + 
                   			'</ul>' + 
                        '</div>';       
			}
			else if (res[i].QuestionType == EXAMTYPE.LIGATURE){
				html += '<div class="cnt" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
                            '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
                            '<ul>' + 
                                '<h5>' + res[i].Content + '</h5>' + 
                    			'<div class="matchByLineBox mlBoxCol">';
                    			var left = '<div class="matchSide matchSideQue">';
                    			var right = '<div class="matchSide matchSideAns">';
                    			for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
	                            	if (res[i].QuestionOptionList[j].OrderNum%2 == 1){
	                            		left += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</div>';
	                            	}
	                            	else if (res[i].QuestionOptionList[j].OrderNum%2 == 0){
	                            		right += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</div>';
	                            	}
	                            }
	                            left += '</div>';
	                            right += '</div>';
                   			html += left + right + 
                   			'</ul>' + 
                   		'</div>'; 
                        html += '<h4 class="hide tipEvt c-wh c_red" style="padding-left:1em;">点击下面内容查看正确答案 : </h4>' + 
                        		'<ul class="hide tipEvt c-wh">' + 
                        			'<div class="matchByLineBox mlBoxCol" style="width:70%;">';
                        			var left = '<div class="matchSide matchSideQue">';
                        			var right = '<div class="matchSide matchSideAns">';
                        			for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
		                            	if (res[i].QuestionOptionList[j].OrderNum%2 == 1){
		                            		for (var l = 0; l < res[i].QuestionOptionList.length; l ++){
		                            			if (res[i].QuestionOptionList[l].OrderNum == res[i].QuestionOptionList[j].OrderNum+1)
		                            				var ans = res[i].QuestionOptionList[l].Id;
		                            		}
		                            		left += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '0" ans="' + ans + '0">' + res[i].QuestionOptionList[j].Content + '</div>';
		                            	}
		                            	else if (res[i].QuestionOptionList[j].OrderNum%2 == 0){
		                            		right += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '0">' + res[i].QuestionOptionList[j].Content + '</div>';
		                            	}
		                            }
		                            left += '</div>';
		                            right += '</div>';
                       			html += left + right + 
                       			'</ul>';   
                       	html +='<div class="hide tipEvt t-bla" style="padding:0 1em 1em 1.5em;"><font style="font-weight:bolder;">解析 : </font>' + res[i].Tip + '</div>'; 
                        		   
			}
			else if (res[i].QuestionType == EXAMTYPE.SORT){
				//冒泡排序,用于正确答案
				var temp = 0;
				var targetArr = res[i].QuestionOptionList;
	            for(var k = 0;k<targetArr.length;k++){
	                for(var j = k;j<targetArr.length;j++){
	                    if(targetArr[k].OrderNum>targetArr[j].OrderNum){
	                        temp = targetArr[k];
	                        targetArr[k] = targetArr[j];
	                        targetArr[j] = temp;
	                     }
	                 }
	            }
				html += '<div class="cnt" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
                            '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
                            '<h5 class="up1">' + res[i].Content + '</h5>' +
                            '<div class="custom_order" id="custom_order">' + 
		                    '    <div class="custom_sort_form">' + 
		                    '        <ul class="sort_div" id="sort_div">';
                    for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
                    	html += '<li class="ub" id="' + res[i].QuestionOptionList[j].Id + '" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" class="drag_li" style="left: 0px; top: 0px;">' + 
                                '    <div class="v_middle ub-f1" id="' + res[i].QuestionOptionList[j].Id + '_h" style="cursor: move;">' + res[i].QuestionOptionList[j].Content + '</div>' + 
                                '	<div class="upp5 ub ub-ac" ontouchstart="zy_touch" onclick="Course.topMove()">上移</div>' + 
                                '	<div class="upp5 ub ub-ac" ontouchstart="zy_touch" onclick="Course.bottomMove()">下移</div>' + 
                                '</li>';
                    }      
	                    html += '	 </ul>' + 
			                    '<h4 class="hide tipEvt c_red" style="padding-left:1em;">正确答案 : </h4>';
			                		for (var j = 0; j < targetArr.length; j ++){
			                        	html += '<li class="hide tipEvt" id="' + targetArr[j].Id + '" data-ordernum="' + targetArr[j].OrderNum + '" class="drag_li" style="left: 0px; top: 0px;width:70%;margin:0.5em auto;">' + 
				                                '    <div class="v_middle" id="' + targetArr[j].Id + '_h" style="cursor: move;">' + targetArr[j].Content + '</div>' + 
				                                '</li>';
		                        	}
	                    	html +='<div class="hide tipEvt t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 : </font>' + res[i].Tip + '</div>' + 
		                        '</div>' + 
		                    '</div>' + 
		                '</div>';            
			}
		}
		$("#" + htmlId).html(html);
		// 初始化连线canvas
		var mblBoxs=$(".matchByLineBox");
		mblArr=[];//全局 存储所有mbl实例
		mblBoxs.each(function(x){
			var mbl=new MatchByLine(mblBoxs.eq(x));
			mbl.init();
			mblArr.push(mbl);
		});
		// 初始化拖动排序
		initDrag();
	},
	topMove: function(){ 
		var $this = $(event.currentTarget);
		var thisHtml = $this.parent().prop('outerHTML');
		var prevHtml = $this.parent().prev().prop('outerHTML');
		if (prevHtml){ 
			$this.parent().prev().before(thisHtml);
			$this.parent().remove();
		} else 
			$alert("向上移不动啦");
	},
	bottomMove: function(){ 
		var $this = $(event.currentTarget);
		var thisHtml = $this.parent().prop('outerHTML');
		var nextHtml = $this.parent().next().prop('outerHTML');
		if (nextHtml){ 
			$this.parent().next().after(thisHtml);
			$this.parent().remove();
		} else 
			$alert("向下移不动啦");
	},
	examSubmit: function(flag){ 
		if (!GetLS("user"))
			return $alert("您未登录，无法提交，是否登录?",function(){OpenNewWin("signup",5)});
		//flag为TRUE 结业考试    false为 每课一练
		var knowledge = GetLS("knowledge");
		if ($(".cnt").length == 0)
			return $alert("还未有题目，耐心等待吧");
		var data = new Object();
		data.isLabour = false;
		data.questions = new Array();
		data.errorSet = new Array();
		var score = 0;
		var nullQuesNum = '';

		$(".issue").find(".cnt").each(function(i){
			data.questions[i] = new Object();
			if (flag == "1")
				data.questions[i] = knowledge.exam[$(this).data("num")];
			else
				data.questions[i] = GetLS("examItem").exam[$(this).data("num")];
			data.questions[i].trueOrFalse = false;
			data.questions[i].cid = GetLS("courseId");
			var QuestionType = $(this).data("questiontype");
			if (QuestionType == EXAMTYPE.SINGLE_CHOICE){
				data.questions[i].stuAnswer = new Array();
				data.questions[i].stuAnswer[0] = $(this).find("input[type='radio']:checked").attr("id");
				if ($(this).find("input[type='radio']:checked").data("ifrightanswer")){
					score += data.questions[i].QScore;
					data.questions[i].trueOrFalse = true;
				} else 
					data.errorSet.push(data.questions[i]);	
				if ($(this).find("input[type='radio']:checked").length == 0){
					nullQuesNum += ($(this).data("num")+1) + ",";
				}	
			}
			else if (QuestionType == EXAMTYPE.MULTIPLE_CHOICE){
				data.questions[i].stuAnswer = new Array();
				var flag = false;
				$(this).find("input[type='checkbox']").each(function(j){
					if ($(this).data("ifrightanswer") && $(this).prop("checked")){
						flag = true;
					} else if (($(this).data("ifrightanswer") && !$(this).prop("checked"))|| (!$(this).data("ifrightanswer") && $(this).prop("checked"))){
						flag = false;
						return false;
					}
				});
				$(this).find("input[type='checkbox']:checked").each(function(j){
					data.questions[i].stuAnswer[j] = $(this).attr("id");
				});
				if (flag){
					score += data.questions[i].QScore;
					data.questions[i].trueOrFalse = true;
				} else 
					data.errorSet.push(data.questions[i]);
				if ($(this).find("input[type='checkbox']:checked").length == 0){
					nullQuesNum += ($(this).data("num")+1) + ",";
				}	
			}
			else if (QuestionType == EXAMTYPE.JUDGE){
				data.questions[i].stuAnswer = new Array();
				data.questions[i].stuAnswer[0] = $(this).find("input[type='radio']:checked").attr("id");
				if ($(this).find("input[type='radio']:checked").data("ifrightanswer")){
					score += data.questions[i].QScore;
					data.questions[i].trueOrFalse = true;
				} else 
					data.errorSet.push(data.questions[i]);
				if ($(this).find("input[type='radio']:checked").length == 0){
					nullQuesNum += ($(this).data("num")+1) + ",";
				}	
			}
			else if (QuestionType == EXAMTYPE.FILL){
				var $evt = $(this);

				data.questions[i].stuAnswer = new Array();
				data.questions[i].stuAnswer[0] = $evt.find("input[type='text']").val();
				data.isLabour = true;
				if ($evt.find("input[type='text']").val() == ""){
					nullQuesNum += ($(this).data("num")+1) + ",";
				}
			}
			else if (QuestionType == EXAMTYPE.SUBJECTIVE){
				var $evt = $(this);

				data.questions[i].stuAnswer = new Array();
				data.questions[i].stuAnswer[0] = $evt.find("textarea").val();
				data.isLabour = true;
				if ($evt.find("textarea").val() == ""){
					nullQuesNum += ($(this).data("num")+1) + ",";
				}
			}
			else if (QuestionType == EXAMTYPE.LIGATURE){
				var $evt = $(this);
				var flag = false;
				var nullFlag = false;
				$(this).find(".matchSideQue .matchOne").each(function(j){
					if ($(this).data("ordernum") == ($("#" + $(this).attr("ans")).data("ordernum") - 1)){
						flag = true;
					}else{
						flag = false;
						return false;
					}
				});
				data.questions[i].stuAnswer = new Array();
				$(this).find(".matchSideQue .matchOne").each(function(j){
					if ($(this).attr("ans"))
						nullFlag = true;
					data.questions[i].stuAnswer[2*j] = $(this).attr("id");
					data.questions[i].stuAnswer[2*j + 1] = $(this).attr("ans");
				});
				if (flag){
					score += data.questions[i].QScore;
					data.questions[i].trueOrFalse = true;
				} else 
					data.errorSet.push(data.questions[i]);
				if (!nullFlag)
					nullQuesNum += ($(this).data("num")+1) + ",";
			}
			else if (QuestionType == EXAMTYPE.SORT){
				var $evt = $(this);
				var flag = false;
				$(this).find(".custom_sort_form li").each(function(j){
					if ($(this).next("li").length != 0){
						if ($(this).data("ordernum") == ($(this).next(".drag_li").data("ordernum") - 1)){
							flag = true;
						}else{
							flag = false;
							return false;
						}
					}	
				});
				data.questions[i].stuAnswer = new Array();
				$(this).find(".custom_sort_form li").each(function(j){
					if (!$(this).hasClass("hide"))
						data.questions[i].stuAnswer[j] = $(this).attr("id");
				});
				if (flag){
					score += data.questions[i].QScore;
					data.questions[i].trueOrFalse = true;
				} else 
					data.errorSet.push(data.questions[i]);
			}
		});
		if (nullQuesNum){
			$alert("您还有" + nullQuesNum + "号试题没有完成，继续完成它吧!");	
			return;
		}
		data.score = score;
		data.student = CurrentUser._id;
		data.courseId = GetLS("courseId");
		data.courseName = GetLS("courseName");
		if (flag == "0") {
			var exam = GetLS("examItem");
			data.homeworkId = exam._id;
			data.chapter = exam.extra;
			data.etype = exam.ctype;
			data.status = 1;
			if (data.etype == 1){ 
				var studyData = {};
				studyData.cid = GetLS("courseId");
				studyData.chid = GetLS("chapter")._id;
				studyData.kid = GetLS("knowledge")._id;
				studyData.field = "homework";
				$ajax({
					url:"/course/study",
					data:studyData,
					success: function(res){
					}
				});	
			}
		} else {
			var studyData = {};
			studyData.cid = GetLS("courseId");
			studyData.chid = GetLS("chapter")._id;
			studyData.kid = GetLS("knowledge")._id;
			studyData.field = "practice";
			$ajax({
				url:"/course/study",
				data:studyData
			});
			$alert("是否查看正确答案和解析？",function(){$(".tipEvt").removeClass("hide")});
			//$alert("这次练习的分数为："+data.score);
			// "practice"  "video"  "homework"
			return;
		}
		console.log(data);
		if (exam.ctype == 1){ 
			$alert("是否查看正确答案和解析？",function(){$(".tipEvt").removeClass("hide")});
			return;
		}
		$ajax({
			url:"/examine/saveExamine",
			data:data,
			success:function(res) {
				if(data.isLabour){
					$alert("完成答题,是否返回？",function(){PCall("course_exam","WinClose();");});
				}else{
					$alert("这次得分为："+data.score + ",是否返回？",function(){PCall("course_exam","WinClose();");});		
				}
			}
		});
	},
	checkFreeCourseLogin: function(){ 
		if (!GetLS("user")){ 
			$alert("您没有权限发表评论或提出问题，是否登录?",function(){OpenNewWin("signup",5)});
		}
	}
}