var Exam = { 
	etype:{1:"阶段性作业",2:"结业考试"},
	examInit: function(){  
		if ($("#courseExamSel").val())
			return;
		var html = '';
		for (var i = 0; i < CurrentUser.course.length; i ++){ 
			var sel = '';
			if (i == 0)
				sel = "selected";
			html += '<option ' + sel + ' value="' + CurrentUser.course[i].id + '">' + CurrentUser.course[i].name + '</option>';
		}	
		$("#courseExamSel").html(html);
		Exam.examFn(CurrentUser.course[0].id);
		$("#selText").text(CurrentUser.course[0].name);
		if (uexWidgetOne.platformName != "android")
			document.getElementById('examBtn').click();
	},
	examFn: function(id){
		$ajax({
			url:"/examine/listPage",
			data:{ 
				courseId: id
			},
			success: function(res) {
				var data = res.result.result;
				var html = '';
				for (var i = 0; i < data.length; i ++){ 
					var etype = data[i].etype;
					var score = data[i].score + '分';
					if (data[i].isLabour)
						score = "未判卷";
					html += '<div class="ub ub-f1 upp5 ubb b_gra" ontouchstart="zy_touch(\'btn-act\')" onclick="Exam.jumpExam(\'' + data[i]._id + '\');">' + 
				        	'	<div class="ub-f1 ut-s ump5" style="width: 40%;">' + data[i].course.name + '</div>' + 
				        	'	<div class="ub-f2 ut-s ump5"  style="width: 25%;">' + Exam.etype[etype] + '</div>' + 
				        	'	<div class="ub-f1 ut-s ump5"  style="width: 15%;">' + score + '</div>' + 
				        	'</div>';
				}
				$("#examList").html(html);
			}
		});		
		$ajax({
			url: "/examine/listErrSet",
			data: { 
				cid: id
			},
			success: function(res){
				var res = res.result;
				var html = "";
				for (var i = 0; i < res.length; i ++){
					html += '<div data-id="' + res[i]._id + '" class="up1 ubb b_gra c_blu2 uf1p4 ut-s" ontouchstart="zy_touch()" onclick="Exam.examErrJump(\'' + res[i]._id + '\');">' + (i + 1) + '.' + res[i].Content + '</div>';
				}	
				$("#errorSet").html(html);
			}
		});
	},	
	jumpExam: function(examId){ 
		SetLS("examId",examId);
		OpenNewWin("exam_detail");
	},
	examDetailInit: function(){ 
		$ajax({
			url : "/examine/getById",
			data: {
				_id: GetLS("examId")
			},
			success: function(res){
				var html = "";
				if (res.result.isLabour)
					html += "<h4 class='up1' style='text-align:right;color:red;'>未判卷</h4>";
				else
					html += "<h4 class='up1' style='text-align:right;color:red;'>阅卷完毕, 得分 : " + res.result.score + "</h4>";
				var res = res.result.questions;
				for (var i = 0; i < res.length; i ++){
					if (res[i].QuestionType == EXAMTYPE.SINGLE_CHOICE){
						html += '<div class="cnt uptb_p5" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
	                                '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
	                                '<ul>' + 
	                                    '<h5>' + res[i].Content + '</h5>';
	                        for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
	                        	var isOrNotChecked = "";
	                        	if (res[i].stuAnswer[0] == res[i].QuestionOptionList[j].Id)
	                        		isOrNotChecked = "checked";
	                        	html += '<li>' + 
	                                        '<label><input type="radio" disabled class="uw2 uh2" ' + isOrNotChecked + ' data-ifrightanswer="' + res[i].QuestionOptionList[j].IfRightAnswer + '" name="' + res[i].QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</label>' + 
	                                    '</li>';
	                        }     
	                        html += '</ul>' + 
	                         		'<h4 style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
		                        	if (res[i].QuestionOptionList[j].IfRightAnswer){
		                        		html += '<p class="t-bla" style="padding-left:3em;">' + res[i].QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		                    //if (res[i].Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res[i].Tip + '</div>';    
	                        html += '</div>';      
					}
					else if (res[i].QuestionType == EXAMTYPE.MULTIPLE_CHOICE){
						html += '<div class="cnt uptb_p5" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
	                                '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
	                                '<ul>' + 
	                                    '<h5>' + res[i].Content + '</h5>';
	                        for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
	                        	var isOrNotChecked = "";
	                        	for (var k = 0; k < res[i].stuAnswer.length; k ++){     
		                        	if (res[i].stuAnswer[k] == res[i].QuestionOptionList[j].Id)
		                        		isOrNotChecked = "checked";
	                        	}
	                        	html += '<li>' + 
	                                        '<label><input type="checkbox" disabled class="uw2 uh2" ' + isOrNotChecked + ' data-ifrightanswer="' + res[i].QuestionOptionList[j].IfRightAnswer + '" name="' + res[i].QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</label>' + 
	                                    '</li>';
	                        }      
	                        html +=  '</ul>' + 
	                        		 '<h4 style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
		                        	if (res[i].QuestionOptionList[j].IfRightAnswer){
		                        		html += '<p class="t-bla" style="padding-left:3em;">' + res[i].QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		                     //if (res[i].Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res[i].Tip + '</div>';        
	                        html += '</div>';      
					}
					else if (res[i].QuestionType == EXAMTYPE.JUDGE){
						html += '<div class="cnt uptb_p5" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
	                                '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
	                                '<ul>' + 
	                                    '<h5>' + res[i].Content + '</h5>';
	                        for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
	                        	var isOrNotChecked = "";
	                        	if (res[i].stuAnswer[0] == res[i].QuestionOptionList[j].Id)
	                        		isOrNotChecked = "checked";
	                        	html += '<li>' + 
	                                        '<label><input type="radio" disabled class="uw2 uh2" ' + isOrNotChecked + ' data-ifrightanswer="' + res[i].QuestionOptionList[j].IfRightAnswer + '" name="' + res[i].QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</label>' + 
	                                    '</li>';
	                        }      
	                        html +=  '</ul>' + 
	                        		 '<h4 style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
		                        	if (res[i].QuestionOptionList[j].IfRightAnswer){
		                        		html += '<p class="t-bla" style="padding-left:3em;">' + res[i].QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		                     //if (res[i].Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res[i].Tip + '</div>';            
                       	 	html += '</div>';       
					}
					else if (res[i].QuestionType == EXAMTYPE.FILL){
						var labour = '(需要人工阅卷)';
						var tscore = '';
						var tcomment = '';
						var ubn = '';
						if (res[i].trueOrFalse != "false"){
							labour = '已阅卷';
							tscore = res[i].trueOrFalse;
							ubn = 'ubn';
							if (res[i].comment)
								tcomment = res[i].comment;
						}
						html += '<div id="' + res[i].Id + '" class="cnt uptb_p5" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
	                                '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分 </span><span style="color:red;"> ' + labour + '</span></h3>' + 
	                                '<ul>' + 
	                                    '<h5>' + res[i].Content + '</h5>' + 
	                        			'<label><input type="text" readonly="true" class="uba uw100 uh2 ump50 uf1p1" id="' + res[i].Id + '" value="' + res[i].stuAnswer[0] + '"></label>';
	                        			for ( var j = 0; j < res[i].QuestionOptionList.length; j ++){
	                        				html += '<input type="hidden" id="' + res[i].QuestionOptionList[j].Id + '" value="' + res[i].QuestionOptionList[j].Content + '">';
	                        			}
	                       	html += '</ul>' + 
	                       			'<div class="upp5 t-bla">' + 
	                       			'	<b>人工阅卷结果</b><br>' + 
	                       			'	分数 : <input type="number" readonly="true" name="score" class="uba uwp15 uh1p5 ump50 uf1p1 ' + ubn + '" value="' + tscore + '">' + 
	                       			'	点评 : <input type="text" readonly="true" name="comment" class="uba uw50 uh1p5 ump50 uf1p1 ' + ubn + '" value="' + tcomment + '">' + 
	                       			'</div>';
	                       	//if (res[i].Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res[i].Tip + '</div>'; 
	                        html +='</div>';      
					}
					else if (res[i].QuestionType == EXAMTYPE.SUBJECTIVE){
						var labour = '(需要人工阅卷)';
						var tscore = '';
						var tcomment = '';
						var ubn = '';
						if (res[i].trueOrFalse != "false"){
							labour = '已阅卷';
							tscore = res[i].trueOrFalse;
							ubn = 'ubn';
							if (res[i].comment)
								tcomment = res[i].comment;
						}	
						html += '<div id="' + res[i].Id + '" class="cnt uptb_p5" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
	                                '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分 </span><span style="color:red;"> ' + labour + '</span></h3>' + 
	                                '<ul>' + 
	                                    '<h5>' + res[i].Content + '</h5>' + 
	                        			'<label><textarea  class="uf1p1" readonly="true" id="' + res[i].Id + '">' + res[i].stuAnswer[0] + '</textarea></label>';
	                        			for ( var j = 0; j < res[i].QuestionOptionList.length; j ++){
	                        				html += '<input type="hidden" id="' + res[i].QuestionOptionList[j].Id + '" value="' + res[i].QuestionOptionList[j].Content + '">';
	                        			}
	                       	html += '</ul>' + 
	                       			'<div class="upp5 t-bla">' + 
	                       			'	<b>人工阅卷结果</b><br>' + 
	                       			'	分数 : <input type="number" readonly="true" name="score" class="uba uwp15 uh1p5 ump50 uf1p1 ' + ubn + '" value="' + tscore + '" >' + 
	                       			'	点评 : <input type="text" readonly="true" name="comment" class="uba uw50 uh1p5 ump50 uf1p1 ' + ubn + '" value="' + tcomment + '" >' + 
	                       			'</div>';
	                       	//if (res[i].Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res[i].Tip + '</div>'; 		
	                        html +='</div>';        
					}
					else if (res[i].QuestionType == EXAMTYPE.LIGATURE){
						html += '<div class="cnt uptb_p5" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
	                                '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
	                                '<ul>' + 
	                                    '<h5>' + res[i].Content + '</h5>' + 
	                                	'<h6 style="padding-left:1em;color:red;">点击下面内容加载连线 : </h6>' + 	                                    
	                        			'<div class="matchByLineBox mlBoxCol">';
	                        			var left = '<div class="matchSide matchSideQue">';
	                        			var right = '<div class="matchSide matchSideAns">';
	                        			for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
			                            	if (res[i].QuestionOptionList[j].OrderNum%2 == 1){
			                            		var ans = '';
		                        				for (var k = 0; k < res[i].stuAnswer.length; k ++){
		                        					if (res[i].QuestionOptionList[j].Id == res[i].stuAnswer[k]){
		                        						ans = res[i].stuAnswer[k+1];
		                        					}
		                        				}
			                            		left += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '" ans="' + ans + '">' + res[i].QuestionOptionList[j].Content + '</div>';
			                            	}
			                            	else if (res[i].QuestionOptionList[j].OrderNum%2 == 0){
			                            		right += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '">' + res[i].QuestionOptionList[j].Content + '</div>';
			                            	}
			                            }
			                            left += '</div>';
			                            right += '</div>';
	                       			html += left + right + 
	                       			'</ul>' + 
	                            '</div>';       
	                        		html += '<h4 style="padding-left:1em;">点击下面内容查看正确答案 : </h4>' + 
			                        		'<ul>' + 
			                        			'<div class="matchByLineBox mlBoxCol" style="width:70%;">';
			                        			var left = '<div class="matchSide matchSideQue">';
			                        			var right = '<div class="matchSide matchSideAns">';
			                        			for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
					                            	if (res[i].QuestionOptionList[j].OrderNum%2 == 1){
					                            		for (var l = 0; l < res[i].QuestionOptionList.length; l ++){
					                            			if (res[i].QuestionOptionList[l].OrderNum == res[i].QuestionOptionList[j].OrderNum+1)
					                            				var ans = res[i].QuestionOptionList[l].Id;
					                            		}
					                            		left += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '0" ans="' + ans + '0">' + res[i].QuestionOptionList[j].Content + '</div>';
					                            	}
					                            	else if (res[i].QuestionOptionList[j].OrderNum%2 == 0){
					                            		right += '<div class="matchOne" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" id="' + res[i].QuestionOptionList[j].Id + '0">' + res[i].QuestionOptionList[j].Content + '</div>';
					                            	}
					                            }
					                            left += '</div>';
					                            right += '</div>';
			                       			html += left + right + 
			                       			'</ul>';
			                       		//if (res[i].Tip)
	                        				html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res[i].Tip + '</div>'; 				
					}
					else if (res[i].QuestionType == EXAMTYPE.SORT){
						//冒泡排序,用于正确答案
						var temp = 0;
						var targetArr = res[i].QuestionOptionList;
			            for(var k = 0;k<targetArr.length;k++){
			                for(var j = k;j<targetArr.length;j++){
			                    if(targetArr[k].OrderNum>targetArr[j].OrderNum){
			                        temp = targetArr[k];
			                        targetArr[k] = targetArr[j];
			                        targetArr[j] = temp;
			                     }
			                 }
			            }
						html += '<div class="cnt uptb_p5" data-num="' + i + '" data-questiontype="' + res[i].QuestionType + '" data-id="' + res[i].Id + '">' + 
	                                '<h3>' + (i + 1) + "." +  res[i].QtypeString + '<span class="score" data-score="' + res[i].QScore + '">' + res[i].QScore + '分</span></h3>' + 
	                                '<h5 class="up1">' + res[i].Content + '</h5>' +
	                                '<div class="custom_order" id="custom_order">' + 
				                    '    <div class="custom_sort_form">' + 
				                    '        <ul class="sort_div" id="sort_div">';
	                        // for (var j = 0; j < res[i].QuestionOptionList.length; j ++){
	                        // 	html += '<li id="' + res[i].QuestionOptionList[j].Id + '" data-ordernum="' + res[i].QuestionOptionList[j].OrderNum + '" class="drag_li" style="left: 0px; top: 0px;">' + 
		                       //          '    <div class="v_middle" id="' + res[i].QuestionOptionList[j].Id + '_h" style="cursor: move;">' + res[i].QuestionOptionList[j].Content + '</div>' + 
		                       //          '</li>';
	                        // }
	                        for (var j = 0; j < res[i].stuAnswer.length; j ++){
	                        	for (var l = 0; l < res[i].QuestionOptionList.length; l ++){
	                        		if (res[i].stuAnswer[j] == res[i].QuestionOptionList[l].Id){
	                        			html += '<li id="' + res[i].QuestionOptionList[l].Id + '" data-ordernum="' + res[i].QuestionOptionList[l].OrderNum + '" class="drag_li" style="left: 0px; top: 0px;">' + 
				                                '    <div class="v_middle" id="' + res[i].QuestionOptionList[l].Id + '_h" style="cursor: move;">' + res[i].QuestionOptionList[l].Content + '</div>' + 
				                                '</li>';
	                        		}
	                        	}
	                        }      
	                         html +=  '</ul>' + 
	                		'<h4 style="padding-left:1em;">正确答案 : </h4>';
	                		for (var j = 0; j < targetArr.length; j ++){
	                        	html += '<li id="' + targetArr[j].Id + '" data-ordernum="' + targetArr[j].OrderNum + '" class="drag_li" style="left: 0px; top: 0px;width:70%;margin:0.5em auto;">' + 
		                                '    <div class="v_middle" id="' + targetArr[j].Id + '_h" style="cursor: move;">' + targetArr[j].Content + '</div>' + 
		                                '</li>';
                        	}
                    		//if (res[i].Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res[i].Tip + '</div>'; 		
                        html += 	'</div>' + 
			                    '</div>' + 
			                '</div>';            
					}
				}
				$("#detailExam").html(html);	
				// 初始化连线canvas
				var mblBoxs=$(".matchByLineBox");
				mblArr=[];//全局 存储所有mbl实例
				mblBoxs.each(function(x){
					var mbl=new MatchByLine(mblBoxs.eq(x));
					mbl.init();
					mblArr.push(mbl);
				});
				// 初始化拖动排序
				initDrag();
			}
		});	
	},
	examErrJump: function(errsetId){ 
		SetLS("errsetId",errsetId);
		OpenNewWin("exam_errorset");
	},
	examErrorDetailInit: function(){ 
		$ajax({
			url: "/examine/detailErrSet",
			data: {
				_id: GetLS("errsetId")
			},
			success: function(res){
				var res = res.result[0];
				var html = "";
				if (res.QuestionType == EXAMTYPE.SINGLE_CHOICE){
					html += '<div class="cnt upb_1" data-questiontype="' + res.QuestionType + '" data-id="' + res.Id + '">' + 
                                '<h3>' + res.QtypeString + ' <span class="score" data-score="' + res.QScore + '"> ' + res.QScore + '分</span></h3>' + 
                                '<ul>' + 
                                    '<h5>' + res.Content + '</h5>';
                        for (var j = 0; j < res.QuestionOptionList.length; j ++){
                        	var isOrNotChecked = "";
                        	if (res.stuAnswer[0] == res.QuestionOptionList[j].Id)
                        		isOrNotChecked = "checked";
                        	html += '<li>' + 
                                        '<label><input type="radio" class="uw2 uh2" disabled ' + isOrNotChecked + ' data-ifrightanswer="' + res.QuestionOptionList[j].IfRightAnswer + '" name="' + res.QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res.QuestionOptionList[j].Id + '">' + res.QuestionOptionList[j].Content + '</label>' + 
                                    '</li>';
                        }      
                        html +=  '</ul>' + 
                        		 '<h4 style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res.QuestionOptionList.length; j ++){
		                        	if (res.QuestionOptionList[j].IfRightAnswer){
		                        		html += '<p class="t-bla" style="padding-left:3em;">' + res.QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
                        	//if (res.Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res.Tip + '</div>'; 		
                        html += '</div>';      
				}
				else if (res.QuestionType == EXAMTYPE.MULTIPLE_CHOICE){
					html += '<div class="cnt upb_1" data-questiontype="' + res.QuestionType + '" data-id="' + res.Id + '">' + 
                                '<h3>' + res.QtypeString + ' <span class="score" data-score="' + res.QScore + '"> ' + res.QScore + '分</span></h3>' + 
                                '<ul>' + 
                                    '<h5>' + res.Content + '</h5>';
                        for (var j = 0; j < res.QuestionOptionList.length; j ++){
                        	var isOrNotChecked = "";
                        	for (var k = 0; k < res.stuAnswer.length; k ++){     
	                        	if (res.stuAnswer[k] == res.QuestionOptionList[j].Id)
	                        		isOrNotChecked = "checked";
                        	}
                        	html += '<li>' + 
                                        '<label><input type="checkbox" class="uw2 uh2" disabled ' + isOrNotChecked + ' data-ifrightanswer="' + res.QuestionOptionList[j].IfRightAnswer + '" name="' + res.QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res.QuestionOptionList[j].Id + '">' + res.QuestionOptionList[j].Content + '</label>' + 
                                    '</li>';
                        }      
                        html +=  '</ul>' + 
                        		 '<h4 style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res.QuestionOptionList.length; j ++){
		                        	if (res.QuestionOptionList[j].IfRightAnswer){
		                        		html += '<p class="t-bla" style="padding-left:3em;">' + res.QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		                //if (res.Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res.Tip + '</div>'; 		        
                        html += '</div>';   
				}
				else if (res.QuestionType == EXAMTYPE.JUDGE){
					html += '<div class="cnt" data-questiontype="' + res.QuestionType + '" data-id="' + res.Id + '">' + 
                                '<h3>' + res.QtypeString + ' <span class="score" data-score="' + res.QScore + '"> ' + res.QScore + '分</span></h3>' + 
                                '<ul>' + 
                                    '<h5>' + res.Content + '</h5>';
                        for (var j = 0; j < res.QuestionOptionList.length; j ++){
                        	var isOrNotChecked = "";
                        	if (res.stuAnswer[0] == res.QuestionOptionList[j].Id)
                        		isOrNotChecked = "checked";
                        	html += '<li>' + 
                                        '<label><input type="radio" class="uw2 uh2" disabled ' + isOrNotChecked + ' data-ifrightanswer="' + res.QuestionOptionList[j].IfRightAnswer + '" name="' + res.QuestionOptionList[j].Exam_BankQuestionId + '" id="' + res.QuestionOptionList[j].Id + '">' + res.QuestionOptionList[j].Content + '</label>' + 
                                    '</li>';
                        }      
                        html +=  '</ul>' + 
                        		 '<h4 style="padding-left:1em;">正确答案 : </h4>';
                        		for (var j = 0; j < res.QuestionOptionList.length; j ++){
		                        	if (res.QuestionOptionList[j].IfRightAnswer){
		                        		html += '<p class="t-bla" style="padding-left:3em;">' + res.QuestionOptionList[j].Content + '</p>';
		                        	}          		
		                        }
		                //if (res.Tip)
                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res.Tip + '</div>'; 		        
                        html += '</div>';        
				}
				else if (res.QuestionType == EXAMTYPE.FILL){
					html += '<div class="cnt" data-questiontype="' + res.QuestionType + '" data-id="' + res.Id + '">' + 
                                '<h3>' + res.QtypeString + '<span class="score" data-score="' + res.QScore + '"> ' + res.QScore + '分</span></h3>' + 
                                '<ul>' + 
                                    '<h5>' + res.Content + '</h5>' + 
                        			'<label><input type="text" id="' + res.Id + '"></label>';
                        			for ( var j = 0; j < res.QuestionOptionList.length; j ++){
                        				html += '<input type="hidden" id="' + res.QuestionOptionList[j].Id + '" value="' + res.QuestionOptionList[j].Content + '">';
                        			}
                       	html += '</ul>';
                       	//if (res.Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res.Tip + '</div>'; 		
                        html +='</div>';      
				}
				else if (res.QuestionType == EXAMTYPE.SUBJECTIVE){
					html += '<div class="cnt" data-questiontype="' + res.QuestionType + '" data-id="' + res.Id + '">' + 
                                '<h3>' + res.QtypeString + '<span class="score" data-score="' + res.QScore + '"> ' + res.QScore + '分</span></h3>' + 
                                '<ul>' + 
                                    '<h5>' + res.Content + '</h5>' + 
                        			'<label><textarea type="text" id="' + res.Id + '"></textarea></label>';
                        			for ( var j = 0; j < res.QuestionOptionList.length; j ++){
                        				html += '<input type="hidden" id="' + res.QuestionOptionList[j].Id + '" value="' + res.QuestionOptionList[j].Content + '">';
                        			}
                       	html += '</ul>';
                       	//if (res.Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res.Tip + '</div>'; 				
                        html +='</div>';       
				}
				else if (res.QuestionType == EXAMTYPE.LIGATURE){
					html += '<div class="cnt" data-questiontype="' + res.QuestionType + '" data-id="' + res.Id + '">' + 
                                '<h3>' + res.QtypeString + '<span class="score" data-score="' + res.QScore + '"> ' + res.QScore + '分</span></h3>' + 
                                '<ul>' + 
                                    '<h5>' + res.Content + '</h5>' + 
                        			'<div class="matchByLineBox mlBoxCol" style="width:70%;">';
                        			var left = '<div class="matchSide matchSideQue">';
                        			var right = '<div class="matchSide matchSideAns">';
                        			for (var j = 0; j < res.QuestionOptionList.length; j ++){
		                            	if (res.QuestionOptionList[j].OrderNum%2 == 1){
		                            		left += '<div class="matchOne" data-ordernum="' + res.QuestionOptionList[j].OrderNum + '" id="' + res.QuestionOptionList[j].Id + '">' + res.QuestionOptionList[j].Content + '</div>';
		                            	}
		                            	else if (res.QuestionOptionList[j].OrderNum%2 == 0){
		                            		right += '<div class="matchOne" data-ordernum="' + res.QuestionOptionList[j].OrderNum + '" id="' + res.QuestionOptionList[j].Id + '">' + res.QuestionOptionList[j].Content + '</div>';
		                            	}
		                            }
		                            left += '</div>';
		                            right += '</div>';
                       			html += left + right;
                       			html +=  '</ul>' + 
               					 '<h4 style="padding-left:1em;">点击下面内容查看正确答案 : </h4>' + 
                        		'<ul>' + 
                        			'<div class="matchByLineBox mlBoxCol" style="width:70%;">';
                        			var left = '<div class="matchSide matchSideQue">';
                        			var right = '<div class="matchSide matchSideAns">';
                        			for (var j = 0; j < res.QuestionOptionList.length; j ++){
		                            	if (res.QuestionOptionList[j].OrderNum%2 == 1){
		                            		for (var l = 0; l < res.QuestionOptionList.length; l ++){
		                            			if (res.QuestionOptionList[l].OrderNum == res.QuestionOptionList[j].OrderNum+1)
		                            				var ans = res.QuestionOptionList[l].Id;
		                            		}
		                            		left += '<div class="matchOne" data-ordernum="' + res.QuestionOptionList[j].OrderNum + '" id="' + res.QuestionOptionList[j].Id + '0" ans="' + ans + '0">' + res.QuestionOptionList[j].Content + '</div>';
		                            	}
		                            	else if (res.QuestionOptionList[j].OrderNum%2 == 0){
		                            		right += '<div class="matchOne" data-ordernum="' + res.QuestionOptionList[j].OrderNum + '" id="' + res.QuestionOptionList[j].Id + '0">' + res.QuestionOptionList[j].Content + '</div>';
		                            	}
		                            }
		                            left += '</div>';
		                            right += '</div>';
                       			html += left + right + 
                       			'</ul>';
                       		//if (res.Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res.Tip + '</div>'; 			
                        html += '</div>';     
				}
				else if (res.QuestionType == EXAMTYPE.SORT){
					//冒泡排序,用于正确答案
					var temp = 0;
					var targetArr = res.QuestionOptionList;
		            for(var i = 0;i<targetArr.length;i++){
		                for(var j = i;j<targetArr.length;j++){
		                    if(targetArr[i].OrderNum>targetArr[j].OrderNum){
		                        temp = targetArr[i];
		                        targetArr[i] = targetArr[j];
		                        targetArr[j] = temp;
		                     }
		                 }
		            }
					html += '<div class="cnt" data-questiontype="' + res.QuestionType + '" data-id="' + res.Id + '">' + 
                                '<h3>' + res.QtypeString + '<span class="score" data-score="' + res.QScore + '">' + res.QScore + '分</span></h3>' + 
                                '<h5 class="up1">' + res.Content + '</h5>' +
                                '<div class="custom_order" id="custom_order">' + 
			                    '    <div class="custom_sort_form">' + 
			                    '        <ul class="sort_div" id="sort_div">';
                        for (var j = 0; j < res.stuAnswer.length; j ++){
                        	for (var l = 0; l < res.QuestionOptionList.length; l ++){
                        		if (res.stuAnswer[j] == res.QuestionOptionList[l].Id){
                        			html += '<li id="' + res.QuestionOptionList[l].Id + '" data-ordernum="' + res.QuestionOptionList[l].OrderNum + '" class="drag_li" style="left: 0px; top: 0px;">' + 
			                                '    <div class="v_middle" id="' + res.QuestionOptionList[l].Id + '_h" style="cursor: move;">' + res.QuestionOptionList[l].Content + '</div>' + 
			                                '</li>';
                        		}
                        	}
                        }      
	                    html +=  '</ul>' + 
	                    	'<h4 style="padding-left:1em;">正确答案 : </h4>';
	                		for (var j = 0; j < targetArr.length; j ++){
                        	html += '<li id="' + targetArr[j].Id + '" data-ordernum="' + targetArr[j].OrderNum + '" class="drag_li" style="left: 0px; top: 0px;width:70%;margin:0.5em auto;">' + 
	                                '    <div class="v_middle" id="' + targetArr[j].Id + '_h" style="cursor: move;">' + targetArr[j].Content + '</div>' + 
	                                '</li>';
                        	}
                        	//if (res.Tip)
	                        	html += '<div class="t-bla" style="padding:1em;"><font style="font-weight:bolder;">解析 :</font> ' + res.Tip + '</div>'; 		
                        html += '</div>' + 
			                    '</div>' + 
			                '</div>';            
				}
				$("#errorDetail").html(html);
				// 初始化连线canvas
				var mblBoxs=$(".matchByLineBox");
				mblArr=[];//全局 存储所有mbl实例
				mblBoxs.each(function(x){
					var mbl=new MatchByLine(mblBoxs.eq(x));
					mbl.init();
					mblArr.push(mbl);
				});
				if (res.QuestionType == EXAMTYPE.LIGATURE){
					for (var k = 0; k < res.stuAnswer.length/2; k ++){     
                    	addOneMatchLineAns({"id": res.stuAnswer[2*k],"answer" : res.stuAnswer[2*k+1]});
                	}
				}
				// 初始化拖动排序
				initDrag();
			}
		});
	}
}