var Lesson = {
	listInit: function() {
		$ajax({
			url: "/course/list",
			data: {
				TYPE:"ITERATIVE",
				GID:CurrentUser.group._id
			},
			success: function(res) {
				SetLS("lesson", res.result);
				var result = res.result;
				var html = "";
				for (var i=0; i<result.length; ++i) {
					html += '<div class="up_list ub" data-pos="'+ i +'" ontouchstart="zy_touch()" onclick="Lesson.jump(\'section\', \''+ i +'\');">'+
						        '<div class="ub-f1 nowrap">'+ result[i].name +'</div>'+
						        '<div class="uw5p5">'+ result[i].chapter.length +'个章节</div>'+
						    '</div>';
					// html += '<div class="hide ufp9">';
					// for (var j=0; j<result[i].chapter.length; ++j) {
					// 	html += '<div class="up_list childctn ub_center" ontouchstart="zy_touch()" onclick="Lesson.jump(\'knowledge\', \''+ j +'\');">'+
					// 		        '<div class="ub_img im_point uw1 uh1"></div>'+
					// 		        '<div class="ub-f1 nowrap">'+ result[i].chapter[j].name +'</div>'+
					// 		        '<div class="uw5p5">'+ result[i].chapter[j].knowledge.length +'个知识点</div>'+
					// 		    '</div>';
					// }
					// html += '</div>';
				}
				$("body").html(html);
			}
		});
	},
	switch: function() {
		var $this = $(event.currentTarget);
		$this.next().toggleClass("hide");
	},
	jump: function(id, pos) {
		if (id == "data")
			SetLS("lesson_knowledge", $(event.currentTarget).parent().prev().data("pos"));
		id = "lesson_"+id;
		SetLS(id, pos);
		if (id == "lesson_section")
			OpenNewWin("lesson_knowledge");
		else
 			OpenNewWin(id);
	},
	sectionInit: function(){
		var sectionPos = GetLS("lesson_section");
		var result = GetLS("lesson")[sectionPos].chapter;
		var html = "";
		for (var i=0; i<result.length; ++i) {
			html += '<div class="up_list" ontouchstart="zy_touch()" onclick="Lesson.jump(\'knowledge\', \''+ i +'\');">'+
				        '<div class="fleft nowrap">'+ result[i].name +'</div>'+
				        '<div class="fright">'+ result[i].knowledge.length +'个知识点</div>'+
				    '</div>';
		}
		$("body").html(html);
	},
	knowledgeInit: function() {
		if (CurrentUser.type == Role.REG_STUDENT || CurrentUser.type == Role.UN_REG_STUDENT)
		    $("#footer").remove();
		var sectionPos = GetLS("lesson_section");
		// var knowledgePos = GetLS("lesson_knowledge");
		var result = GetLS("lesson")[sectionPos].chapter;
		var html = "";
		for (var i=0; i<result.length; ++i) {
			html += '<div class="up_list ub" data-pos="'+ i +'" ontouchstart="zy_touch()" onclick="Lesson.switch();">'+
				        '<div class="ub-f1 nowrap">'+ result[i].name +'</div>'+
				        '<div class="uw5p5">'+ result[i].knowledge.length +'个知识点</div>'+
				    '</div>';
			var knowledge = result[i].knowledge;
			html += '<div class="hide ufp9">';
			for (var j=0; j<knowledge.length; ++j) {
				var count = 0;
				if (knowledge[j].info) {
					count += knowledge[j].info.content?knowledge[j].info.content.length:0;
					count += knowledge[j].info.video?knowledge[j].info.video.length:0;
				}

				html += '<div class="up_list childctn ub_center" data-pos="'+ j +'" ontouchstart="zy_touch()" onclick="Lesson.jump(\'data\', \''+ j +'\');">'+
							'<div class="ub_img im_point uw1 uh1"></div>'+
					        '<div class="ub-f1 nowrap">'+ knowledge[j].name +'</div>'+
					        '<div class="ub" ontouchstart="zy_touch()" onclick="Lesson.checked()"><div>'+ count +'个素材</div>';
				if (CurrentUser.type == Role.TEACHER){
					var im = "im_checkbox_normal";
					if (knowledge[j].today)
						im = "im_checkbox_selected";
					html += '<div data-id="'+ knowledge[j]._id +'" class="ub_img '+ im +' uw1p5 uh1p5 uml_1"></div>';
				}
				html += '</div></div>';
			}
			html += '</div>';
		}
		$("body").html(html);
	},
	checked: function(action){
		var $this = $(event.currentTarget).children(".ub_img");
		if (action == "odd-even") {
			if ($this.hasClass("im_checkbox_selected"))
				$this.removeClass("im_checkbox_selected").addClass("im_checkbox_normal");
			else {
				$this.parents(".que").find(".ub_img").removeClass("im_checkbox_selected").addClass("im_checkbox_normal");
				$this.removeClass("im_checkbox_normal").addClass("im_checkbox_selected");
			}
		} else {
			if ($this.hasClass("im_checkbox_normal"))
				$this.removeClass("im_checkbox_normal").addClass("im_checkbox_selected");
			else
				$this.removeClass("im_checkbox_selected").addClass("im_checkbox_normal");
		}
		event.stopPropagation();
	},
	setKnowledge: function(action) {
		var data = {};
		var obj = [];
		data.IDS = [];
		if (action == "set")
			data.TYPE = "ADD";
		else if (action == "cancel")
			data.TYPE = "DEL";
		$(".im_checkbox_selected").each(function(i) {
			obj[i] = {
				parentPos: $(this).parents(".ufp9").prev().data("pos"),
				nowPos: $(this).parents(".childctn").data("pos")
			}
			data.IDS.push($(this).data("id"));
		})
		if (data.IDS.length == 0) {
			$alert("请选择要设置的知识点");
			return;
		}
		data.GID = CurrentUser.group._id;
		$ajax({
			url: "/course/setKnowledge",
			data: data,
			success: function(res){
				var lessonObj = GetLS("lesson");
				var sectionPos = GetLS("lesson_section");
				for (z=0; z<obj.length; ++z) {
					var chapterPos = obj[z].parentPos;
					var knowledgePos = obj[z].nowPos;
					lessonObj[sectionPos].chapter[chapterPos].knowledge[knowledgePos].today = (action == "set");
				}
				// var knowledgePos = GetLS("lesson_knowledge");
				// var result = lessonObj[sectionPos].chapter[knowledgePos].knowledge;
				// for (var i=0; i<result.length; ++i) {
				// 	for (var j=0; j<data.IDS.length; ++j) {
				// 		var flag = true;
				// 		if (result[i]._id == data.IDS[j]) {
				// 			result[i].today = (action == "set");
				// 			flag = false;
				// 			break;
				// 		}
				// 	}
				// }
				if (action == "set")
					$toast("设置知识点成功");
				else
					$toast("取消知识点成功");
				SetLS("lesson", lessonObj);
			}
		});
	},
	dataInit: function(id) {
		var knowledge = GetLS("knowledge").info;
		var html = "";
		if (id == "video") {
			var result = knowledge.video;
			for (var i=0; i<result.length; ++i) {
				html += '<div class="up_list ub" ontouchstart="zy_touch()" onclick="uexVideo.open(\''+ Core.VIDEO_VER+result[i].attach +'\', 1)">'+
					        '<div class="ub-f1">'+ result[i].name +'</div>'+
					    '</div>';
			}
		}
		else if (id == "material") {
			var result = knowledge.content;
			for (var i=0; i<result.length; ++i) {
				html += '<div class="up_list ub" ontouchstart="zy_touch()" onclick="Lesson.openHtml(\''+ result[i].attach.replace(".docx", ".html") +'\');">'+
					        '<div class="ub-f1">'+ result[i].name +'</div>'+
					    '</div>';
			}
		}
		$("body").html(html);
	},
	openHtml: function(url) {
		PCall('lesson_data', 'Zycon("'+ Core.ATTACH_VER+url +'", $("#header").outerHeight())');
	},
	examInit: function() {
		var knowledge = GetLS("knowledge");
		$ajax({
			url: "/exam/list",
			data: {PID:knowledge._id, PTYPE:"K"},
			success: function(res){
				var choice = res.result.choice;
				var judge = res.result.judge;

				var html = "";
				var no = 1;
				html += '<div id="scoreEvent" class="up_list hide">你的得分为：</div>';
				if (choice.length) {
					html += '<div class="up_list"><div class="ub_center uf1p4">多选题</div>';
					for (var i=0; i<choice.length; ++i) {
						html += '<div class="uptb_1 que"><div>'+ (no.toString().length==1?"0"+no:no) + ". " + choice[i].que.name +'</div>';
						++no;
						var answer = choice[i].que.answer;
						var answerStr = "";
						for (var j=0; j<answer.length; ++j) {
							if (answer[j].status)
								answerStr += answer[j].name + "，";
							html += '<div class="ub uptb_p5" ontouchstart="zy_touch()" onclick="Lesson.checked()">'+
										'<div class="ub_img im_checkbox_normal uw1p5 uh1p5 umr_lrp5" data-status="'+ answer[j].status +'"></div>'+
										'<div class="ub-f1">'+ answer[j].name +'</div>'+
									'</div>';
						}
						html += '<div class="answerEvent hide">正确答案：'+ answerStr.substring(0, answerStr.length-1) +'</div>';
						html += '<div class="answerEvent hide">答题解析：'+ (choice[i].que.answerTip==""?"无":choice[i].que.answerTip) +'</div>';
						html += '</div>';
					}
					html += '</div>';
				}
				if (judge.length) {
					html += '<div class="up_list"><div class="ub_center uf1p4">判断题</div>';
					for (var i=0; i<judge.length; ++i) {
						html += '<div class="uptb_1 que"><div>'+ (no.toString().length==1?"0"+no:no) + ". " + judge[i].que.name +'</div>';
						++no;
						var answer = judge[i].que.answer;
						var answerStr = "";
						for (var j=0; j<answer.length; ++j) {
							if (answer[j].status)
								answerStr += answer[j].name + "，";
							html += '<div class="ub uptb_p5" ontouchstart="zy_touch()" onclick="Lesson.checked(\'odd-even\')">'+
										'<div class="ub_img im_checkbox_normal uw1p5 uh1p5 umr_lrp5" data-status="'+ answer[j].status +'"></div>'+
										'<div class="ub-f1">'+ answer[j].name +'</div>'+
									'</div>';
						}
						html += '<div class="answerEvent hide">正确答案：'+ answerStr.substring(0, answerStr.length-1) +'</div>';
						html += '<div class="answerEvent hide">答题解析：'+ (choice[i].que.answerTip==""?"无":choice[i].que.answerTip) +'</div>';
						html += '</div>';
					}
					html += '</div>';
				}
				$("#ctn").html(html);
			}
		});
	},
	examSubmit: function() {
		var flag = false;
		var correctNum = 0;
		$(".que").each(function(i){
			if ($(this).find(".im_checkbox_selected").length == 0) {
				$alert("试题"+(i.toString().length==1?"0"+(i+1):(i+1))+"没有回答");
				flag = true;
				return false;
			}
		});
		if (flag)
			return;
		$(".que").each(function(i){
			flag = false;
			$(this).find(".ub_img").each(function(){
				if (!(($(this).data("status") == true && $(this).hasClass("im_checkbox_selected")) ||
					($(this).data("status") == false && $(this).hasClass("im_checkbox_normal")))) {
					flag = true;
				}
			});
			if (!flag)
				++correctNum;
		});
		var knowledge = GetLS("knowledge");

		var num = $(".que").length;
		var score = parseInt((correctNum/num)*100);
		if (CurrentUser.type == Role.TEACHER) {
			$("#scoreEvent").append(score+"分").show();
			$(".answerEvent").removeClass("hide");
			$(document).scrollTop(0);
		} else {
			$ajax({
				url:"/exam/addScore",
				data: {
					PID:knowledge._id,
					PTYPE:"K",
					NUM: num,
					SCORE: score
				},
				success: function(res){
					//if (GetLS("WINID") == "lesson_data") {
						$("#scoreEvent").html("你的得分为:"+score+"分" + "<span class='c-blu t-wh uinn' style='float:right;' ontouchstart='zy_touch()' onclick='Lesson.scoreShare(\"" + score + "\");'>分享</span>").show();
						$(".answerEvent").removeClass("hide");
						$(document).scrollTop(0);
					//} 
					//else {
					//	PCall("work", "CCall('Work.getKnowledgeList();');");
					//	PCall("work_exam_detail", "WinClose()");
					//}
				}
			});
		}
	},
	scoreShare: function(score){
		uexWeiXin.registerApp('wx0d993c72c28f4878');
		uexWeiXin.cbIsWXAppInstalled=function(opCode,dataType,data){
			if (data) {
				var sence = 1;
				var thumImgPath = 'http://www.baidu.com';
				var realImgPath = 'http://www.baidu.com';
				uexWeiXin.cbSendImageContent = function(opCode,dataType,data){
					alert(data)
				};
				if (uexWidgetOne.platformName == "android")
					uexWeiXin.sendImageContent(sence, thumImgPath, realImgPath, "", "", "");
				else
					uexWeiXin.sendImageContent(sence, thumImgPath, realImgPath);
				alert(Alert.SUC, "分享成功");
			} else {
				alert(Alert.SUC, "没有安装微信客户端，无法完成分享");
			}
		};
		uexWeiXin.isWXAppInstalled();
	}	
}