var IsPhone = (window.navigator.platform != "Win32");
var IsAndroid = (window.navigator.userAgent.indexOf('Android')>=0)?true : false;
var IsLoading = false;
var Timeout = 0;
var BODY_WIDTH = $(window).width();
var BODY_HEIGHT = $(window).height();
var href = window.location.href;
var HTMLID = href.substring(href.lastIndexOf("/") + 1).replace(".html", "");
// var API_VER = "http://api.kidsfeet.cn";
// var API_VER = "http://123.57.8.173";
var API_VER = "http://localhost";

// var IMG_VER = "http://api.kidsfeet.cn/upload/image/";
// var IMG_VER = "http://123.57.8.173/upload/image/";
var IMG_VER = "http://localhost/upload/image/";

var STR_SPLIT = "||*||";

var VERSION = "1.0.0";

/**
 * @param String inWndName 新窗口名称
 * @param String html		新窗口路径
 * @param String inAniID	打开动画
 * @param String f
 */
function OpenNewWin(id, aimID){
	SetLS("WINID", id);
	if (!aimID)
		aimID = 10;
	uexWindow.open(id, 0, id + ".html", aimID, "", "", 0, 350);
}

/**
 * 关闭窗口
 * @param string n 关闭窗口动画，默认-1
 */
function WinClose(n){
	if (n) {
		uexWindow.close(n);
		return;
	}
	uexWindow.close(-1);
}

function Zycon(url, top, id){
	var bottom = $(".footerEvent").outerHeight();
	if (!bottom)
		bottom = 0;

	if (!id)
		id = "content";

	if (id == $(".footerEvent").attr("id") || $(".footerEvent").hasClass("hide"))
		bottom = 0;

	if (uexWidgetOne.platformName != "android" && url != "chat_detail_content" && url != "space_detail_content")
		bottom = 0;
	if (url.indexOf(".html") == -1)
		url += ".html";
	zy_con(id, url, 0, top, bottom);
}

/**
 * 输出loag
 * @param String s 需要输出的信息
 * @param String a 添加的标注信息
 */
function Logs(s,a){
	if(typeof s == 'object'){
		s = JSON.stringify(s);
	}
	a = a ? a : "";
	if(!isPhone){
		console.log(a+s);
	}else{
		uexLog.sendLog(a+s);
	}
}

/**
 * localStorage保存数据
 * @param String key  保存数据的key值
 * @param String value  保存的数据
 */
function SetLS(key, json){
	window.localStorage.setItem(key, JSON.stringify(json));
}

/**
 * 根据key取localStorage的值
 * @param Stirng key 保存的key值
 */
function GetLS(key){
	var str = window.localStorage.getItem(key);
	if (str != null && str != "")
		return JSON.parse(str);
	else
		return false;
}

/**
 * 清除缓存
 * @param Striong key  保存数据的key，如果不传清空所有缓存数据
 */
function ClearLS(key){
	if(key)
		window.localStorage.removeItem(key);
	else
		window.localStorage.clear();
}

function CCall(js, id){
	if (!id)
		id = "content";
	uexWindow.evaluatePopoverScript("", id, js);
}

function PCall(id, js){
	uexWindow.evaluateScript(id, 0, js);
}

/**
 * 判断是否是空
 * @param value
 */
function IsDefine(value){
    if(value == null || value == "" || value == "undefined" || value == undefined || value == "null" || value == "(null)" || value == 'NULL' || typeof(value) == 'undefined'){
        return false;
    }
    else{
		value = value+"";
        value = value.replace(/\s/g,"");
        if(value == ""){
            return false;
        }
        return true;
    }
}

// arg[0] = String title
// arg[1] = String cancel
// arg[2] = Array  actionSheet
// arg[3...] = Function actionSheetArr click callback
function ActionSheet() {
	var args = arguments;
	if (args.length < 3) {
		console.log("ActionSheet args length < 3");
		return;
	}
	uexWindow.cbActionSheet = function(opId, dataType, data) {
		if (data == args[2].length)
			return;
		var i = Number(data) + 3;
		if (args[i] == undefined)
			args[3](data);
		else
			args[i](data);
	}
	uexWindow.actionSheet(args[0], args[1], args[2]);
}


function ImageBrowser(url) {
	var arr = new Array();
	var no = 0;
	$(".photoBrowserEvent").each(function(i) {
		var src = $(this).data("url");
		if (src != "undefined") {
			arr.push(Core.id2url(src, "photo"));
		}
		if (src == url)
			no = arr.length-1;
	});
	uexImageBrowser.open(arr, no, 1);
}

/**
 * alert 和 confirm 弹出框
 * @param String str 提示语
 * @param Function callback confirm的回调函数
 */
function $alert(str,callback){
	if(callback){
		uexWindow.cbConfirm = function(opId,dataType,data){
			if(data == 0)
				callback(); 
		}
		uexWindow.confirm('提示',str,['确定','取消']);
	}else
		uexWindow.alert('提示',str,'确定');
}

/**
 * 显示加载框
 * @param String mes 显示的提示语
 * @param String t  毫秒数 窗口存在时间 有的话显示框不显示那个“圈”，并且在t时间后消失
 */
function $toast(mes,t){
	uexWindow.toast(t?'0':'1','5',mes,t?t:2000);
}

/**
 * 手动关闭加载框
 */
function $closeToast(){
	uexWindow.closeToast();
}

/**设置安卓back和menu按键事件监听
 * @b: back键，1为监听。
 * @m: menu键，1为监听。
 * @cb1: back键监听处理回调方法。
 * @cb2: menu键监听处理回调方法。
 */
function AddKeyListener(b, cb1, m, cb2){
	uexWindow.onKeyPressed = function(keyCode){
		if(keyCode==0){
			if(cb1)  cb1();
			//uexWidget.finishWidget(''); //退出应用
		}
		else{
			if(cb2) cb2();
		}
	}
	if(b) uexWindow.setReportKey('0', '1');
	if(m) uexWindow.setReportKey('1', '1');
}

// 设置ios7头部透明问题
function Add20ToHeader(){
  if (uexWidgetOne.platformName == "android")
      return;
  if (GetLS('IOS7Plus')) {
      try {
          if (GetLS('IOS7Plus') == 2) {
              if ($("#header").css("padding-top")) {
                  $("#header").css("padding-top", parseInt($("#header").css("padding-top")) + 20) + "px";
              }
              else {
              	$("#header").css("padding-top", "20px");
              }
          }
      } 
      catch (e) {
      }
  }
  else {
      uexDevice.cbGetInfo = function(opId, dataType, data){
          if (data) {
              var device = JSON.parse(data);
              var os = parseInt(device.os);

              if (os >= 7) {
                  SetLS('IOS7Plus',2);
                  try {
                      if ($("#header").css("padding-top"))
                  		$("#header").css("padding-top", parseInt($("#header").css("padding-top")) + 20) + "px";
                      else
              			$("#header").css("padding-top", "20px");
                  } 
                  catch (e) {
                  }
              } else {
              	SetLS('IOS7Plus', 1);
              }
		 	}
      };
		 uexDevice.getInfo('1');
  }
}
function OpenAttach(name, url) {
	Download.download(Core.ATTACH_VER+url, "attach/"+name, function(status){
		if (status == 1) {
			uexDocumentReader.openDocumentReader("wgt://data/attach/"+name);
			// var opId = parseInt(Math.random()*10000);
		 //    uexFileMgr.cbGetFilePath = function (opId,dataType, data){
			// 	uexFileMgr.cbGetFilePath = null;
		 //        if(dataType==0){
			// 		data = "file://"+data;
			// 		var mime = data.substring(data.lastIndexOf(".")+1);
		 //    		uexWidget.loadApp("android.intent.action.VIEW", Core.MIME[mime], data);
		 //        }
		 //    	uexFileMgr.closeFile(opId);
		 //    }
		 //    uexFileMgr.openFile(opId, Download.savedPath, 1);
		 //    uexFileMgr.getFilePath(opId);

		}
	}, true);
}