var Space = {
	items: null,
	listInit: function(fromID) {
		var data = {START:0, COUNT:1000};
		$ajax({
			url: "/bbs/list",
			data: data,
			success: function(res) {
				var html = "";
				var items = res.result;
				if (items.length == 0) {
					$("#ctn").html('<div class="ub_center up_base c_base">暂无数据</div>');
					return;
				}
				Space.items = items;
				for (var i=0; i<items.length; ++i) {
					html += '<div class="ub up_list" ontouchstart="zy_touch()" onclick="Space.gotoListDetailInit(\''+ i +'\')">'+
								'<div class="uw3p5 ub-f1">'+ items[i].fromName +'</div>'+
								'<div class="uw7 ufp8 ub_center">'+ (new Date(items[i].create)).pattern("yyyy-MM-dd") +'</div>'+
								'<div class="uw3 ub_center ufp8">'+ items[i].count +'条</div>'+
							'</div>';
				}
				$("#ctn").html(html);
			}
		});
	},
	gotoListDetailInit: function(pos) {
		SetLS("space_list", Space.items[pos]);
		OpenNewWin("space_list_detail");
	},
	listDetailInit: function() {
		var item = GetLS("space_list");
		var data = {START:0, COUNT:50, FROM:item._id};

		$ajax({
			url: "/bbs/list",
			data: data,
			success: function(res) {
				var html = "";
				var items = res.result;
				Space.items = items;
				for (var i=0; i<items.length; ++i) {
					html += '<div class="ub up_list" ontouchstart="zy_touch()" onclick="Space.gotoDetail(\''+ i +'\')">'+
								'<div class="ub-f1 nowrap">'+ items[i].title +'</div>'+
							'</div>';
				}
				$("#ctn").html(html);
			}
		});
	},
	gotoDetail: function(pos) {
		SetLS("space_list_detail", Space.items[pos]);
		OpenNewWin("space_detail");
	},
	detailInit: function() {
		var item = GetLS("space_list_detail");
		$("#ctn").html('<div class="up_list uf1p2">'+ item.content +'</div>');
		if (item.attach) {
		    $("#ctn").append('<div id="attach" class="up_list" ontouchstart="zy_touch()" onclick="OpenAttach(\''+ item.fileName +'\', \''+ item.attach +'\')">'+
						        '<div style="font-weight:bold;">展示议题附件</div>'+
						        '<div class="ub umt_1">'+
						            '<div class="ub-img im_attach uw3p5 uh2p5"></div>'+
						            '<div id="filename" class="nowrap ub ub-ac">'+ item.fileName +'</div>'+
						        '</div>'+
						    '</div>');
		}


		var ajaxAfterFun = function(items, user){
			// setTimeout(tmoFun, 1000*2);
			var html = Chat.gnHtml(items, user);
			$("#chatCtn").append(html);
		}
		var tmoFun = function(){
			$ajax({
				url: "/bbs/detail",
				data: {ID:item._id},
				success: function(res) {
					var answer = res.result.answer;
					for (var i=0; i<answer.length; ++i) {
						answer[i].media = 0;
					}
					ajaxAfterFun(res.result.answer, "self");
				}
			});
		};
		tmoFun();
	},
	send: function() {
		var item = GetLS("space_list_detail");
		var msgcontent = $("#msg").val();
		if (msgcontent == "") {
			$alert("留言内容不能为空");
			return;
		}
		$("#msg").val("");

		$ajax({
			url: "/bbs/reply",
			data: {ID:item._id, CONTENT:msgcontent},
			success: function(res) {
				res.result.media = 0;
				CCall("Space.sendAppend('" + JSON.stringify(res.result) + "')");
			}
		});
	},
	sendAppend: function(item) {
		item = JSON.parse(item);
		var html = Chat.gnHtml(new Array(item), "self");
		$("#chatCtn").append(html);
		if (html != "")
			$(document).scrollTop($(document).height());
	},
	choseFile: function() {
		Upload.init(Core.API_VER+"/homework/submitFile", function(res){
			res = res[0];
			if (!res.code) {
				Space.url = res.result.url;
				Space.filename = res.result.filename;
				$("#attach").show();
				$("#filename").text(Space.filename);
				$("#attach").attr("onclick", 'OpenAttach("'+ Space.filename +'", "'+ Space.url +'")');
			}
		}, false, true);
	}
}